'
' Modified on 08/01/2003:
'
' Added "SetButtonImage" proceedure to set button Icons.
'
' Updated INCLUDE file with new Win32API declares with the
' exception of the declaration for "CreateProcess".
'
' File will now compile under v6.x or v7.x of the PB Compiler.
'
'
'
' Lil HTTP v2.2d Source File:  Summit Computer Networks, Inc.
' Donated to the Public Domain October 10, 2001 by Scott Slater
' and Summit Computer Networks, Inc..  This project was started
' primarily as a learning experience and to give me something
' that I could test my CGI's on that could be distributed
' along with them without requiring a 3rd party server.
'
' All I would ask is that if anyone adds anything significant
' to this code, that they would make it available again to the
' people of the PowerBASIC forums as well as myself.  I do
' truly appreciate all of the great source code examples that
' are posted there, and the knowlege of the many people that
' are willing to share with others.  I will continue working
' on this project and encourage others to join in.  I would
' like to see possibly other types of scripting support added
' in the future as well as anything else that can be done to
' improve this project.
'
' Credits: Ben Clark - I Used his HTTP Server Code as a
'                      starting point for Lil HTTP.
'
'      Borje Hagsten - Web Sub-Classing Routines and Calendar
'                      example.
'
'       E B Knoppert - Tool Tips Code
'
'      Lance Edmonds - IpToString code, MimeType Function & help
'                      on the radio style pushbuttons
'
'   And I also want to thank all of those who post on the PB
' Forums.  If I missed anybody, I am sorry.  I've gotten a
' great deal of code from various places that I don't always
' remember...
'
'                         Enjoy!
'
'                             Scott Slater
'
' [Requires PBDLL6 or PBWIN7 to compile]
' Pre-Compiled versioin w/Installer & sample CGI's available
' at http://www.summitcn.com/download.html
'
#Compile Exe
#Dim All
'#Debug Error On

#Resource "LilHTTP.pbr"

'// Disable certain sections of the commctrl.inc that are not used.
%NOANIMATE       = 1
%NOBUTTON        = 1
%NOCOMBO         = 1
'%NODATETIMEPICK  = 1
%NODRAGLIST      = 1
%NOEDIT          = 1
%NOFLATSBAPIS    = 1
%NOHEADER        = 1
%NOHOTKEY        = 1
%NOIMAGELIST     = 1
%NOIPADDRESS     = 1
%NOLIST          = 1
%NOLISTVIEW      = 1
%NOMONTHCAL      = 1
%NONATIVEFONTCTL = 1
%NOPAGESCROLLER  = 1
%NOPROGRESS      = 1
%NOREBAR         = 1
%NOSTATUSBAR     = 1
'%NOTABCONTROL    = 1
%NOTOOLBAR       = 1
%NOTOOLTIPS      = 1
%NOTRACKBAR      = 1
%NOTREEVIEW      = 1
%NOUPDOWN        = 1

'#Include "win32api.inc"  ' Windows 32-Bit API Declares
'#Include "commctrl.inc"  ' Common Controls for (TabCtl & Calendar)
#Include "LilHTTP.inc"   ' WinApi and Common Controls Includes

%WM_TRAYICON = %WM_USER + 400   ' Tray Icon Calls
%WM_CONNECT  = %WM_USER + 500   ' TCP Connect Msgs

' tcp message types
%FD_ACCEPT                  = &H008
%FD_CLOSE                   = &H020

' *************************************************************
'
'  Configuration Settings Struc
'
'  This struc is stored in a file called  LilHTTP.CFG
'
'     Flag Bits:  0  Reserved
'                 1  ON = SSI Enabled
'                 2  ON = Security Enabled (Set At Start)
'                 3  ON = Server Was Last ON
'                 4  ON = Logging ON
'                 5  ON = Logging Text/Html Hits ONLY
'                 6  ON = Use Registry Content-Type Info
Type HTTPCFG
     RootDir  As Asciiz * 120   ' Server Root Directory
     CGIDir   As Asciiz * 120   ' CGI Files Directory
     LogDir   As Asciiz * 120   ' Log Files Directory
     IndexFl  As Asciiz * 20    ' Index (Startup) File Name
     Flag     As Dword          ' See Above
     SrvNam   As Asciiz * 120   ' Server Name
     DefPort  As Long           ' Default Port
     IpAddr   As Long           ' Server IP Address
     MaxConn  As Dword          ' Max Connections
End Type

' Directory Records Stored in LilHTTP.DRS
Type Directs
     DirName  As Asciiz * 128   ' Directory Name
End Type

' User Records Stroed in LilHTTP.USR
Type UserAcct
     UserName As Asciiz * 41   ' User Login ID
     UserPW   As Asciiz * 21   ' User PW
     UserExp  As Dword         ' ExpDate in DateToDays, 0 = None
     UserDirs As Asciiz * 256  ' Comma delimited string of dir names
     Reserved As Asciiz * 190  ' Future Use
End Type

' Internal Variable for Threads
'
'    InUse Values - 0=NotInUse, 1=InUse, 2=ReqestToEnd
Type ConnectionStruct
     hSocket  As Long   ' Connection's Socket handle (PB)
     hThread  As Long   ' Thread Handle
     InUse    As Dword  ' Flag to determine connections status.
End Type

' Used in Function IpAddr in webtcp.inc
Union in_addr
  s_addr      As Long
  s           As String * 4
End Union

' Used in Function IpAddr in webtcp.inc
Type sockaddr_in
  sin_family  As Word
  sin_port    As Word
  sin_addr    As in_addr
  sin_zero    As String * 8
End Type

' App Name
$ApTitle = "Lil' HTTP Server by Summit Computer Networks"
$StrVers = "2.2d"

Global hWnd_ToolTip    As Long  ' Main ToolTip Handle
Global hDlg            As Long  ' Main Window Handle
Global aDlg            As Long  ' About Window Handle
Global TabNum()        As Long  ' Tab Handles
Global hFont1          As Long  ' Font Handle
Global hFont2          As Long  ' Font Handle
Global ti              As NOTIFYICONDATA  ' Tray Icon Info
Global p               As POINTAPI ' Pop-Up Menu Info
Global hMenu           As Long  ' Menu handle
Global DirRecs         As Long  ' Number of Directory Records
Global UsrRecs         As Long  ' Number of User Records
Global Dirs()          As Directs ' Array Of Secured Directories
Global User()          As UserAcct ' Array Of User Accounts
Global SavDirStr       As String  ' For Directory Editor Rtns
Global SavUsrRec       As UserAcct ' For User Editor Rtns
Global DataPos         As Long  ' Index for Dup Searches in DBs
Global oldWebproc1     As Long  ' Original Sub-Class Proc
Global CursorHand      As Long  ' Mouse Cursor Flag

'Webserver Globals

Global gCfg            As HTTPCFG  ' Global Cfg Settings
Global gSrvRunning     As Long  ' Global Run Flag
Global ListenSocket    As Long  ' Socket for listening
Global Connections()   As ConnectionStruct ' Holds Connection handles
Global BADCHARS        As String
Global WebDir          As String
Global CGIDir          As String


' tcp declare
Declare Function getsockname Lib "wsock32.dll" Alias "getsockname" _
   (ByVal s As Long, sname As sockaddr_in, namelen As Long) As Long


Sub SplitDate(ByVal InDate As String, Month As Long, _
              Day As Long, Year As Long)

  Local x1 As Long, x2 As Long

  If Len(InDate) = 0 Then
    InDate = Date$
  End If

  x1 = InStr(1, Indate, Any "-/")
  x2 = InStr(x1 + 1, InDate, Any "-/")

  Month = Val(Mid$(InDate, 1, x1 - 1))
  Day = Val(Mid$(InDate, x1 + 1, x2 - x1 - 1))
  Year = Val(Mid$(InDate, x2 + 1))

  If Year < 80 Then        'assume we've rolled into the next century
    Year = Year + 2000
  ElseIf Year < 100 Then   'between 80 and 99, use this century
    Year = Year + 1900
  End If

End Sub

Function MakeDate(ByVal Month As Long, ByVal Day As Long, _
                  ByVal Year As Long) As String

  Local Temp As String

  If Year < 80 Then        'assume we've rolled into the next century
    Year = Year + 2000
  ElseIf Year < 100 Then   'between 1980 and 1999
    Year = Year + 1900
  End If

  Temp = Format$(Month, "00") & "-" & _
         Format$(Day, "00") & "-" & _
         Format$(Year, "0000")

  Function = Temp

End Function

Function Leap(ByVal Year As Long) As Long

  Function = 0
  If Year Mod 4 = 0 Then
    Function = 1
    If Year Mod 100 = 0 Then
      If Year Mod 400 <> 0 Then Function = 0
    End If
  End If

End Function

' ** Modified version to start at 2K!
'
'
Function DateToDays(ByVal InDate As String) As Dword

  Local Month        As Long
  Local Day          As Long
  Local Year         As Long
  Local LastYear     As Long
  Local x            As Long
  Local NumDays      As Dword
  Local DaysPerMonth As String
  Local pDPM         As Byte Ptr

  SplitDate InDate, Month, Day, Year

  If Year < 2000 Then Exit Function

  'Calculate number of days from 1/1/0001 through 12/31 of previous year,
  'assuming present system of calculating leap years.
  'Then subtract number of days from 1/1/0001 through 12/31/1999 (730119)
  'Result is number of days since 12/31/1999, i.e. 1/1/2000 = 1

  LastYear = Year - 1
  NumDays = LastYear * 365 + LastYear\4 - LastYear\100 + LastYear\400 - 730119

  'set up table of days per month
  x = 28 + Leap(Year)
  DaysPerMonth = Chr$(31,x,31,30,31,30,31,31,30,31,30,31)
  pDPM = StrPtr(DaysPerMonth)

  Decr Month
  Do While Month
    NumDays = NumDays + @pDPM
    Incr pDPM
    Decr Month
  Loop

  NumDays = NumDays + Day

  Function = NumDays

End Function

' Modified version to start at 2K!
'
'
Function DaysToDate(ByVal NumDays As Dword) As String

  Local Temp         As Dword
  Local LastYear     As Long
  Local LeapDays     As Long
  Local x            As Long
  Local pDPM         As Byte Ptr
  Local DaysPerMonth As String
  Local Year         As Long
  Local Month        As Long
  Local Day          As Long

  'Adjust back to number of days since 1/1/0001
  Temp = NumDays + 730119

  LastYear = Temp \ 365
  LeapDays = LastYear\4 - LastYear\100 + LastYear\400
  Day = Temp Mod 365 - LeapDays

  'Day is now less than 1.  Correct that by backing up a
  'year at a time until Day > 0.

  Do While Day < 1
    Day = Day + 365 + Leap(LastYear)
    Decr LastYear
  Loop

  Year = LastYear + 1

  'set up a table of days in each month and access it with a pointer
  x = 28 + Leap(Year)
  DaysPerMonth = Chr$(31,x,31,30,31,30,31,31,30,31,30,31)

  Month = 1
  pDPM = StrPtr(DaysPerMonth)
  Do While Day > @pDPM
    Day = Day - @pDPM
    Incr Month
    Incr pDPM
  Loop

  Function = MakeDate(Month, Day, Year)

End Function

' Convert a string IP address to a LONG
'
Function StringToIp(ip As String) As Long

  Local b As Byte Ptr
  Local lng As Long

  b = VarPtr(lng)

  If Tally(ip,".") = 3 Then
     @b[0] = 255 And Val(Parse$(ip,".",1))
     @b[1] = 255 And Val(Parse$(ip,".",2))
     @b[2] = 255 And Val(Parse$(ip,".",3))
     @b[3] = 255 And Val(Parse$(ip,".",4))
     Function = lng
  Else
     Function = 0
  End If

End Function

'
' Convert a LONG Ip address to a dot-notated string
'
Function IpToString(ByVal ip As Long) As String

  Local b As Byte Ptr

  If ip > 0 Then
     b = VarPtr(ip)
     Function = Format$(@b[0]) & "." & Format$(@b[1]) & "." & _
                Format$(@b[2]) & "." & Format$(@b[3])
  Else
     Function = "0.0.0.0"
  End If

End Function

' Retrieve the Client's IP Address based on the
' PB Socket Handle
'
Function TcpAddr(ByVal s As Long) As Long

  Local sa As sockaddr_in
  Local l  As Long

  s = FileAttr(s,2) ' Convert to Winsock Socket Handle
  l = SizeOf(sa)

  If getsockname(s, sa, l) = 0 Then
    Function = sa.sin_addr.s_addr   'Return the IP Address
  End If

End Function

Function CvtNvtByte(ByVal x As Long) As Long

   Local rtn As Long

   ! push eax              ; save eax since we alter it
   ! push ebx              ; save ebx since we alter it

   ! mov eax, x            ; get byte into eax
   ! and eax, 255          ; clear other bytes
   ! cmp eax, 64           ; see if its an upper case letter
   ! jle CvtNvtCheck47     ; if not check to see if its = 43
   ! cmp eax, 91           ; can't be bigger than 90
   ! jge CvtNvtCheck96     ; otherwize not what we thought
   ! sub eax, 65           ; subtract 65 from the original
   ! mov rtn, eax          ; return that value to caller
   ! jmp CvtNvtDone        ; leave the function

   CvtNvtCheck96:
   ! cmp eax, 96           ; looking for lower case letters
   ! jle CvtNvtRtn63       ; return 63
   ! cmp eax, 123          ; see if we're less then 123
   ! jge CvtNvtRtn63       ; return 63
   ! sub eax, 71           ; subtract 71 and
   ! mov rtn, eax          ; return it to the caller
   ! jmp CvtNvtDone        ; leave the function

   CvtNvtCheck47:
   ! cmp eax, 47           ; see if its a /, 0-9
   ! jle CvtNvtCheck43     ; see if its a + next
   ! cmp eax, 58           ; no more than 57 acceptable
   ! jge CvtNvtRtn63       ; return 63
   ! add eax, 4            ; add 4 to eax
   ! mov rtn, eax          ; return it to the caller
   ! jmp CvtNvtDone        ; leave the function

   CvtNvtCheck43:
   ! cmp eax, 43           ; see if its a + sign
   ! jne CvtNvtRtn63       ; if not do next check
   ! mov ebx, 62           ; return value 62
   ! mov rtn, ebx          ; to the caller
   ! jmp CvtNvtDone        ; exit function

   CvtNvtRtn63:
   ! mov ebx, 63           ; return 63 for any other bytes
   ! mov rtn, ebx          ; not specified

   CvtNvtDone:
   ! pop ebx               ; restore original ebx
   ! pop eax               ; restore original eax

   Function = rtn          ' Pass Return Value to caller

End Function

' ---------------------------------------------------------
' BASE64 Decoding Routine: Returns 1 on Error
'                                  0 for Success
'
' Args:  Pointr to Input Buffer, Pointer to Output Buffer,
'        Output Buffer's Size.
' ---------------------------------------------------------
Function Base64Dec(lpStringIn As Asciiz, lpStringOut As Asciiz, _
                   ByVal OutBuffSiz As Dword) As Long

   Local rtn As Long

   ! push ebx              ; save ebx
   ! push esi              ; save esi
   ! push edi              ; save edi
   ! mov esi, lpStringIn   ; input buffer address
   ! and esi, esi          ; null ptr check
   ! jz Base64DecDone      ; exit function
   ! mov edi, lpStringOut  ; output buffer address
   ! and edi, edi          ; null ptr check
   ! jz Base64DecDone      ; exit function

   ! xor ebx, ebx          ; zero ebx
   ! xor ecx, ecx          ; zero ecx
   ! xor edx, edx          ; zero edx

   Base64DecLoop:
   ! xor eax, eax          ; zero eax register
   ! mov bl, [esi]         ; get character from input
   ! cmp bl, 0             ; see if it's a null terminator
   ! je Base64DecDone      ; if so then exit function
   ! push ebx              ; parameter for next call
   ! call CvtNvtByte       ; call the function
   ! shl al, 2             ; shift bits in result left by 2
   ! mov ecx, eax          ; save it to ecx
   ! mov bl, [esi+1]       ; get next char from input
   ! push ebx              ; parameter for call
   ! call CvtNvtByte       ; call function
   ! shr al, 4             ; shift result bits right by 4
   ! or ecx, eax           ; or result 1 with result 2
   ! mov edx, ecx          ; save ecx to edx
   ! mov bl, [esi+2]       ; get third letter
   ! cmp bl, 61            ; see if its an = sign
   ! je Base64DecBC1       ; append it to the output buffer
   ! mov bl, [esi+1]       ; get second letter
   ! push ebx              ; paramter for call
   ! call CvtNvtByte       ; call function
   ! shl al, 4             ; shift result left by 4
   ! mov ecx, eax          ; save the result in ecx
   ! mov bl, [esi+2]       ; get the 3rd char from input
   ! push ebx              ; set it as parameter for call
   ! call CvtNvtByte       ; call the function
   ! shr al, 2             ; shift the result right by 2
   ! or ecx, eax           ; or reslult 2 with result 3
   ! mov dh, cl            ; save it in dh
   ! mov bl, [esi+3]       ; get 4th char from input
   ! cmp bl, 61            ; see if its an = sign
   ! je Base64DecBC2       ; append it to the output buffer
   ! mov bl, [esi+2]       ; get 3rd char
   ! push ebx              ; set it as param for call
   ! call CvtNvtByte       ; call the function
   ! shl al, 6             ; shift result left 6
   ! mov ecx, eax          ; save it to ecx
   ! mov bl, [esi+3]       ; get the 4th char
   ! push ebx              ; set it as parameter for call
   ! call CvtNvtByte       ; call the function
   ! or ecx, eax           ; or it with the modified third
   ! jmp Base64DecBC3      ; process the output

   Base64DecBC1:
   ! mov [edi], dl         ; write byte to output
   ! inc edi               ; update the pointer
   ! mov eax, 1            ; set an error code
   ! cmp edi, OutBuffSiz   ; see if we're out of buffer space
   ! je Base64DecDone      ; if so exit
   ! add esi, 4            ; prepare for next block
   ! jmp Base64DecLoop     ; go back for more

   Base64DecBC2:
   ! mov [edi], dl         ; write byte to output
   ! inc edi               ; update the pointer
   ! mov eax, 1            ; set an error code
   ! cmp edi, OutBuffSiz   ; see if we're out of buffer space
   ! je Base64DecDone      ; if so exit
   ! shr edx, 8            ; move dh to dl
   ! jmp Base64DecBC1      ; process the last char

   Base64DecBC3:
   ! mov eax, edx          ; copy edx to eax
   ! shr edx, 8            ; move dh to dl
   ! mov dh, cl            ; copy cl to dh
   ! mov [edi], al         ; write byte to output
   ! inc edi               ; move pointer up 1
   ! mov eax, 1            ; set an error code
   ! cmp edi, OutBuffSiz   ; see if we're out of buffer space
   ! je Base64DecDone      ; if so exit
   ! jmp Base64DecBC2      ; process remaining 2 bytes


   Base64DecDone:
   ! pop edi               ; restore edi
   ! pop esi               ; restore esi
   ! pop ebx               ; restore ebx
   ! cmp eax, 1            ; see if we have an error
   ! je Base64DecError
   ! jmp Base64DecExit

   Base64DecError:
   ! mov rtn, eax          ; save our return value in rtn
   Function = rtn          ' and return it to caller.

   Base64DecExit:

End Function

#If 0   ' Function not used by HTTP Server

' ---------------------------------------------------------
' BASE64 Encoding Routine: Returns 0 for success,
'                             Non-Zero for Error Code
'
' Args:  Pointr to Input Buffer, Pointer to Output Buffer,
'        In Sring Len, Output Buffer's Size.
'
' Note: In String Len is used rather than looking for the
'       zero terminator so that Binary Data can be encoded!
'
' Err Codes:  1 = OutPut Buffer Null Ptr Error
'             2 = InPut Buffer Null Ptr Error
'             4 = OutPut Buffer Too Short!
' ---------------------------------------------------------
Function Base64Enc(lpStringIn As Asciiz, lpStringOut As Asciiz, _
                   ByVal InLen As Dword, ByVal OutBuffSiz As Dword) As Long

   Local rtn As Long

   ! push ebx              ; save ebx
   ! push esi              ; save esi
   ! push edi              ; save edi
   ! mov ecx, lpStringOut  ; pointer to output buffer
   ! push ecx              ; save the address in case of err
   ! mov eax, 1            ; Null pointer error code
   ! and ecx, ecx          ; check for null pointer
   ! jz Base64EncDone      ; if so get out
   ! mov edi, lpStringIn   ; pointer to input buffer
   ! mov eax, 2            ; Null pointer error code
   ! and edi, edi          ; see if its a null pointer
   ! jz Base64EncDone      ; if so get out
   ! xor esi, esi          ; zero esi
   ! mov edx, InLen        ; edx contains Instr Len
   ! lea ebx, Base64_Nvt   ; load translation table to ebx

   Base64EncTop:
   ! xor eax, eax          ; error code 0
   ! cmp edx, 0            ; see if we're at the end
   ! je Base64EncDone      ; if so then exit function
   ! mov al, [edi]         ; get character into al
   ! shr al, 2             ; Shift Right 2 bits
   ! xlatb                 ; translate the character
   ! mov [ecx], al         ; save it
   ! inc ecx               ; move pointer up 1
   ! pop eax               ; get original address of output
   ! push eax              ; save it again
   ! mov esi, ecx          ; get current Output pos
   ! sub esi, eax          ; get current output len
   ! mov eax, 4            ; error code into eax
   ! add esi, 4            ; translate it to len
   ! cmp esi, OutBuffSiz   ; see if we've reached the limit
   ! jge Base64EncDone     ; if so exit with an error
   ! mov al, [edi+1]       ; read char2 into al
   ! mov ah, [edi]         ; read char1 into ah
   ! shr ax, 4             ; shift it all r by 4
   ! and al, &H3F          ; and the low byte w/0x3F
   ! xlatb                 ; translate the low bit
   ! mov [ecx], al         ; save it
   ! inc ecx               ; move pointer up 1
   ! cmp edx, 1            ; see which position we are in
   ! jne Base64EncSec2     ; jump to section 2
   ! mov al, 61            ; append the == to end
   ! mov [ecx], al         ; save it once
   ! inc ecx               ; move the pointer up
   ! mov [ecx], al         ; save it once more
   ! mov al, 61            ; 2nd = sign
   ! inc ecx               ; up the pointer again
   ! xor eax, eax          ; return error code 0
   ! jmp Base64EncDone     ; exit the function

   Base64EncSec2:
   ! mov al, [edi+2]       ; read the 3rd char into al
   ! mov ah, [edi+1]       ; read the 2nd char into ah
   ! shr ax, 6             ; shift it all right 6 bits
   ! and al, &H3F          ; and the low byte w/0x3F
   ! xlatb                 ; translate the char
   ! mov [ecx], al         ; save it to output buffer
   ! inc ecx               ; move output buff ptr up
   ! cmp edx, 2            ; see if were at pos 2
   ! jne Base64EncSec3     ; if not jump to section 3
   ! mov al, 61            ; otherwise add an = to end
   ! mov [ecx], al         ; save it
   ! inc ecx               ; update the pointer
   ! xor eax, eax          ; return error code 0
   ! jmp Base64EncDone     ; exit the function

   Base64EncSec3:
   ! mov al, [edi+2]       ; read 3rd char into al
   ! and al, &H3F          ; and it with 0x3F
   ! xlatb                 ; translate it
   ! mov [ecx], al         ; save it
   ! inc ecx               ; update output pointer
   ! add edi, 3            ; prepare for next block of chars
   ! sub edx, 3            ; move input string pointer down
   ! jmp Base64EncTop      ; go back to the top for next block

   Base64_Nvt:
   ! db 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90
   ! db 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122
   ! db 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 43, 47

   Base64EncDone:
   ! pop esi               ; recall original output addr (ecx)
   ! cmp eax, 0            ; see if an error got us here
   ! jne Base64Error       ; yep so handle it
   ! mov [ecx], al         ; save null terminator
   ! mov rtn, eax          ; return error code
   ! jmp Base64ExitProc    ; exit the proceedure

   Base64Error:
   ! mov rtn, eax          ; return error code
   ! and eax, 3            ; see if it was a null ptr error
   ! jnz Base64ExitProc    ; exit directly
   ! xor eax, eax          ; zero eax
   ! mov [esi], al         ; write a null terminator

   Base64ExitProc:
   ! pop edi               ; restore edi
   ! pop esi               ; restore esi
   ! pop ebx               ; restore ebx

   Function = rtn          ' return code to caller

End Function

#EndIf

Function StartTimer(tValue As Long) As Long
   Local hTimer  As Long

   If tValue = 0 Then
      Function = 0
      Exit Function
   End If
   hTimer = Timer
   If hTimer + tValue > 86400 Then
      Function = hTimer + tValue - 86400
   Else
      Function = hTimer + tValue
   End If
End Function

Function Expired(tValue As Long) As Integer
   Local hTimer  As Long

   hTimer = Timer
   ' Did we roll over past midnight
   If hTimer > tValue Then
      Function = %True
   Else
      Function = %False
   End If
End Function

' This value needs to be returned to the calling
' browser.
'
Function GetContentLength(Cmd As String) As Long
   Function = Val(Mid$(Cmd, 17))
End Function

' See if a user-defined 404 or 401 page exists.  If so use it!
Function GetErrPage(ByVal Which As Long) As String

   Local ErrFile As String
   Local FileNum As Long
   Local hTimer  As Long
   Local iWork   As Long

   If Which Then
      ErrFile = "LILHTTP.404"
   Else
      ErrFile = "LILHTTP.401"
   End If

   If Len(Dir$(WebDir & ErrFile)) = 0 Then Exit Function

   FileNum = FreeFile
   hTimer = StartTimer(60)

   Do
      ' If someone is using it, then wait for them
      Open WebDir & ErrFile For Binary Shared As FileNum
      If ErrClear Then
         iWork = 1
         Sleep 1000
         Close FileNum
      Else
         iWork = 0
      End If
      If Expired(hTimer) Then
         Exit Loop
      End If
      If iWork = 0 Then Exit Loop
   Loop

   If Expired(hTimer) Then
      Close FileNum
      Exit Function
   Else
      ErrFile = Space$(Lof(FileNum))
      Get$ FileNum, Lof(FileNum), ErrFile
      Close FileNum
   End If

   Function = ErrFile

End Function

Function html_401error As String
   'This is the 401 error page that is showed when the page
   ' that is requested is password protected & password is
   ' not valid.
   Local s As String
   Local x As String

   s = GetErrPage(0)
   If Len(s) Then
      Function = s
      Exit Function
   End If

   s = Trim$(gCfg.SrvNam)
   x = ""
   x = x & "<html>" & $CrLf
   x = x & "<head>" & $CrLf
   x = x & "  <title>HTTP 401 Unauthorized Access</title>" & $CrLf
   x = x & "</head>" & $CrLf
   x = x & $CrLf
   x = x & "<body bgcolor=""#000000"" text=""#FFFF00"">" & $CrLf
   x = x & "<h1 align=""center"">"& s & "</h1>" & $CrLf
   x = x & "<h1 align=""center"">Powered By Lil' HTTP Server</h1>" & $CrLf
   x = x & "<p><h3 align=""center"">From Summit Computer Networks</p></p></h3></p>" & $CrLf
   x = x & "<p align=""center""><font face=""Verdana, Arial, Helvetica, sans-serif"" size=""4""><b><font color=""#FF0000""
   x = x & ">A Password is required to view the requested page. </font></b></font></p>" & $CrLf
   x = x & "<p></p>" & $CrLf
   x = x & "<p><font face=""Verdana, Arial, Helvetica, sans-serif"" size=""2"">The username/password you " & $CrLf
   x = x & " supplied is not a valid username/password combo for this page." & $CrLf
   x = x & "</font></p>" & $CrLf
   x = x & "<p align=""center""></p>" & $CrLf
   x = x & "<p align=""center""><font size=""7"" face=""Verdana, Arial, Helvetica, sans-serif"" color=""#FF0000""><i><font color=""#FF0000"">HTTP" & $CrLf
   x = x & "  401 - Unauthorized Access</font></i></font></p>" & $CrLf
   x = x & "</body>" & $CrLf
   x = x & "</html>" & $CrLf
   Function = x
End Function

Function html_404error As String
   'This is the 404 error page that is showed when the page
   ' that is requested isn't found.
   Local s As String
   Local x As String

   s = GetErrPage(1)
   If Len(s) Then
      Function = s
      Exit Function
   End If

   s = Trim$(gCfg.SrvNam)
   x = ""
   x = x & "<html>" & $CrLf
   x = x & "<head>" & $CrLf
   x = x & "   <title>HTTP 404 Not Found</title>" & $CrLf
   x = x & "</head>" & $CrLf
   x = x & $CrLf
   x = x & "<body bgcolor=""#000000"" text=""#FFFF00"">" & $CrLf
   x = x & "<h1 align=""center"">" & s & "</h1>" & $CrLf
   x = x & "<h1 align=""center"">Powered By Lil' HTTP Server</h1>" & $CrLf
   x = x & "<p><h3 align=""center"">From Summit Computer Networks</p></p></h3></p>" & $CrLf
   x = x & "<p align=""center""><font face=""Verdana, Arial, Helvetica, sans-serif"" size=""4""><b><font color=""#FF0000""
   x = x & ">The requested page cannot be found. </font></b></font></p>" & $CrLf
   x = x & "<p></p>" & $CrLf
   x = x & "<p><font face=""Verdana, Arial, Helvetica, sans-serif"" size=""2"">The page you are" & $CrLf
   x = x & "  looking for might have been removed, had its name changed, or is temporarily" & $CrLf
   x = x & "  unavailable. </font></p>" & $CrLf
   x = x & "<p align=""center""></p>" & $CrLf
   x = x & "<p align=""center""><font size=""7"" face=""Verdana, Arial, Helvetica, sans-serif"" color=""#FF0000""><i><font color=""#FF0000"">HTTP" & $CrLf
   x = x & "  404 - File not found</font></i></font></p>" & $CrLf
   x = x & "</body>" & $CrLf
   x = x & "</html>" & $CrLf
   Function = x
End Function

Sub StdOut(hStdIO As Long, ByVal x As String)
   Local Buffer As Asciiz * 1024
   Local Result As Long

   Buffer = x
   ' Write to Standard Output device
   Result = WriteFile(hStdIO, Buffer, Len(x), ByCopy 0, ByVal 0)
End Sub

Sub StdOutLn(hStdIO As Long, ByVal x As String)
   ' Write to the standard output device with a CRLF
   StdOut hStdIO, x & $CrLf
End Sub

Sub ReleaseRedirectIO(FileNum As Long)
   ' Close the Standard IO redirect
   CloseHandle FileNum
End Sub

Function RedirectIO(FileIO As String, ReadOnly As Integer) As Long
   Local FileNum    As Long
   Local Count      As Long
   Local SecAttrib  As SECURITY_ATTRIBUTES
   Local FileIOz    As Asciiz * 256

   FileIOz = FileIO

   If Trim$(FileIO) = "" Then
      Function = 0
      Exit Function
   End If
   ' What is the length of the structure
   SecAttrib.nLength = SizeOf(SecAttrib)
   ' What security descriptor do we use. NONE
   SecAttrib.lpSecurityDescriptor = %NULL
   ' Cause the new process to inherit its Standard IO from this process
   SecAttrib.bInheritHandle = %True
   ' If the IO will be readonly
   If ReadOnly Then
       ' Try 5 times
      For Count = 1 To 5
          ' Create a readonly file and redirect its IO to our process
          FileNum = CreateFile(FileIOz, %GENERIC_READ, %FILE_SHARE_READ, SecAttrib, _
                              %CREATE_ALWAYS, %FILE_ATTRIBUTE_NORMAL Or %FILE_FLAG_WRITE_THROUGH, %NULL)
          ' Did it work???
          If FileNum = %INVALID_HANDLE_VALUE Then
             ' No, so rest a while and try again. The file may be in use
             Sleep 1000
          Else
             ' Yes. Now we can leave
             Exit For
          End If
      Next Count
   Else
      For Count = 1 To 5
          ' It is Read/Write so open the file and redirect its IO to our process
          FileNum = CreateFile(FileIOz, %GENERIC_READ Or %GENERIC_WRITE, _
                               %FILE_SHARE_READ Or %FILE_SHARE_WRITE, SecAttrib, _
                               %CREATE_ALWAYS, %FILE_ATTRIBUTE_NORMAL Or %FILE_FLAG_WRITE_THROUGH, %NULL)
          If FileNum = %INVALID_HANDLE_VALUE Then
             Sleep 1000
          Else
             Exit For
          End If
      Next Count
      If FileNum = %INVALID_HANDLE_VALUE Then
         Function = 0
         Exit Function
      End If
      ' Move the pointer to the end of the file
      SetFilePointer FileNum, 0, %NULL, %FILE_END
   End If

   Function = FileNum

End Function

Function GetExt(Snippet As String) As String
   Local ExtStart   As Long
   Local ExtEnd     As Long
   Local Extension  As String
   ' Establish filename for datatype.
   ' If the request is for CGI, then the HTML page request will be followed
   ' by the CGI information. This information is separated from the page request by
   ' the char ?
   ' If the period is located after this char, then the users request did not includ an extension
   ' but looks like a CGI request.
   ExtStart = InStr(Snippet, ".") + 1
   If ExtStart = 0 Then
      ' They didn't give one so assume html
      Extension = "html"
   End If
   ' Look for the end of the extension
   ExtEnd = InStr(ExtStart, Snippet, " ")
   ' Did we find the space marking the end
   If ExtEnd = 0 Then
      ' This could be a CGI type request.
      ' GET /page.html?Fld=data&Fld=data HTTP/1.x
      ' Find the ? seperator
      ExtEnd = InStr(ExtStart, Snippet, "?")
      If ExtEnd = 0 Then
         ExtEnd = Len(Snippet) + 1
      End If
   Else
      ' OK we found the space. Is it where we expect it to be
      If ExtEnd > InStr(ExtStart, Snippet, "?") Then
         ' This is a CGI type request. The space we found is not the one we want
         ' GET /page.html?Fld=data&Fld=data HTTP/1.x
         '  We must have found this space ^
         ' Find the ? seperator
         ExtEnd = InStr(ExtStart, Snippet, "?")
      End If
   End If
   ' Get the extension
   Extension = Mid$(Snippet, ExtStart, ExtEnd - ExtStart)
   Function = Extension
End Function

Function GetHTTPVer(Snippet As String) As String

   Local HttpStart  As Long

   ' Every request should have 2 spaces in the GET/POST/etc.. section
   ' GET /page.html?Fld=data&Fld=data HTTP/1.x
   ' Find the first space
   HttpStart = InStr(Snippet, " ")
   If HttpStart = 0 Then
      Function = ""
      Exit Function
   Else
      ' Find the second space
      HttpStart = InStr(HttpStart, Snippet, " ")
      If HttpStart = 0 Then
         Function = ""
         Exit Function
      Else
         ' Take everything past the second space
         Function = Mid$(Snippet, HttpStart + 1)
         Exit Function
      End If
   End If
End Function

Function GetCGIData(Snippet As String, vData As String, _
                     CGIExe As String) As Long
   Local CGIDataStart   As Long
   ' GET /page.html?Fld=data&Fld=data
   ' Find the ?
   CGIDataStart = InStr(Snippet, "?")
   If CGIDataStart = 0 Then
      vData = ""
      Function = 0
      Exit Function
   Else
      Incr CGIDataStart
   End If
   CGIExe = Left$(Snippet, CGIDataStart - 2)
   ' Take everything past the ?
   vData = Mid$(Snippet, CGIDataStart)
   Function = ParseCount(vData , "&")
End Function

Function GetMimeType(ByVal fileExt As String) As String

  Local hKey    As Long
  Local Result  As Long
  Local KeyType As Long
  Local buffer  As Asciiz * 64
  Local s       As Long

' ** We need a valid file extension
  If IsFalse InStr(fileExt, ".") Then
    fileExt = "." & fileExt
  Else
    fileExt = Mid$(fileExt, InStr(-1, fileExt, "."))
  End If

' ** Open the section
  If RegOpenKeyEx(%HKCR, ByCopy fileExt, 0, %KEY_ALL_ACCESS, _
                  hKey) <> %ERROR_SUCCESS Then
    Function = "undefined"
    Exit Function
  End If

' ** Get the key value
  s = SizeOf(buffer)
  RegQueryValueEx hKey, "Content Type", 0, %REG_SZ, buffer, s

' ** Close the registry
  RegCloseKey hKey

' ** Check to see if it's defined
  If IsFalse Len(buffer) Then
    buffer = "undefined"
  End If

' ** Return the data
  Function = buffer

End Function

Function GetContentType(Extension As String, Executable As Integer) As String
   Local ContentType  As String

   Executable = %False

   If Bit(gCfg.Flag,6) Then    ' Use Registry Entry
      ContentType = GetMimeType(LCase$(Extension))
      If ContentType <> "undefined" Then
         If LCase$(Extension) = "cgi" Or LCase$(Extension) = "exe" Then
            Executable = %True
         End If
         Function = ContentType
         Exit Function
      End If
   End If

   Select Case LCase$(Extension)
       Case "htm", "html", "bas", "txt", "asp"
           ContentType = "text/html"
       Case "bmp", "dib"
           ContentType = "image/bmp"
       Case "png"
           ContentType = "image/png"
       Case "jpg", "jpeg"
           ContentType = "image/jpeg"
       Case "gif"
           ContentType = "image/gif"
       Case "exe", "com", "bat", "cgi", "cmd", "bin"
           ContentType = "text/html"
           Executable = %True
       Case Else
           ContentType = "application/octet-stream"
   End Select
   Function = ContentType
End Function

Function SetReqData(RequestType As String, Accepts As String, AcceptLanguage As String, _
                    AcceptEncoding As String, Authorization As String, UserAgent As String, _
                    ClientHost As String, Connection As String, Referer As String, _
                    ContentLength As Long) As String

   Local sWork  As String

   sWork = "<P></P>" & $CrLf & "<P><STRONG>Request Data Recieved from Client:</STRONG></P>"
   sWork = sWork & "<P>&nbsp;</P>" & $CrLf & "<P>&nbsp;</P>"
   sWork = sWork & "<P>Accept: <STRONG>" & Accepts & " </STRONG></P>" & $CrLf
   sWork = sWork & "<P>Accept-Language: <STRONG>" & AcceptLanguage & "</STRONG></P>" & $CrLf
   sWork = sWork & "<P>Accept-Encoding: <STRONG>" & AcceptEncoding & "</STRONG></P>" & $CrLf
   sWork = sWork & "<P>Authorization: <STRONG>" & Authorization & "</STRONG></P>" & $CrLf
   sWork = sWork & "<P>User-Agent: <STRONG>" & UserAgent & "</STRONG></P>" & $CrLf
   sWork = sWork & "<P>Host: <STRONG>" & ClientHost & "</STRONG></P>" & $CrLf
   sWork = sWork & "<P>Connection: <STRONG>" & Connection & "</STRONG></P>" & $CrLf
   sWork = sWork & "<P>Referer: <STRONG>" & Referer & "</STRONG></P>" & $CrLf
   sWork = sWork & "<P>Content-Length: <STRONG>" & Format$(ContentLength) & "</STRONG></P> " & $CrLf
   sWork = sWork & "<P>&nbsp;</P>" & $CrLf & "<P>&nbsp;</P>"

   Function = sWork

End Function

Function SetEnvData(RequestType As String, ExtraData As String, Authorization As String, _
                    ClientHost As String, Accepts As String, AcceptLanguage As String, _
                    AcceptEncoding As String, UserAgent As String, Referer As String, _
                    Connection As String) As String

   Local EnvData    As String
   Local LocalHost  As String
   Local LocalIp    As Long
   Local SrvrName   As String
   Local Auth_type  As String

   If Len(Authorization) Then
      Auth_type = "BASIC" & Authorization
   Else
      Auth_type = ""
   End If

   SrvrName = Trim$(gCfg.SrvNam)
   Host Name To LocalHost
   Host Addr LocalHost To LocalIp
   ' Set environment variable for CGI stuff
   EnvData = "REQUEST_METHOD=" & RequestType & $Nul
   EnvData = EnvData & "CONTENT_LENGTH=" & Format$(Len(ExtraData)) & $Nul
   EnvData = EnvData & "QUERY_STRING=" & ExtraData & $Nul
   EnvData = EnvData & "QUERY_STRING_UNESCAPTED=" & $Nul
   EnvData = EnvData & "AUTH_TYPE=" & Auth_Type & $Nul
   EnvData = EnvData & "REMOTE_ADDRESS=" & ClientHost & $Nul
   EnvData = EnvData & "REMOTE_HOST=" & ClientHost & $Nul
   EnvData = EnvData & "SERVER_SOFTWARE=LilHTTP/" & $StrVers & $Nul
   EnvData = EnvData & "SERVER_NAME=" & SrvrName & $Nul
   EnvData = EnvData & "GATEWAY_INTERFACE=" & $Nul
   EnvData = EnvData & "SERVER_PROTOCOL=" & $Nul
   EnvData = EnvData & "SERVER_PORT=" & Format$(gCfg.DefPort) & $Nul
   EnvData = EnvData & "PATH_INFO=" & $Nul
   EnvData = EnvData & "PATH_TRANSLATED=" & $Nul
   EnvData = EnvData & "SCRIPT_NAME=" & $Nul
   EnvData = EnvData & "REMOTE_USER=" & $Nul
   EnvData = EnvData & "REMOTE_IDENT=" & $Nul
   EnvData = EnvData & "HTTP_ACCEPT=" & Accepts & $Nul
   EnvData = EnvData & "HTTP_ACCEPT_CHARSET=" & $Nul
   EnvData = EnvData & "HTTP_ACCEPT_ENCODING=" & AcceptEncoding & $Nul
   EnvData = EnvData & "HTTP_ACCEPT_LANGUAGE=" & AcceptLanguage & $Nul
   EnvData = EnvData & "HTTP_USER_AGENT=" & UserAgent & $Nul
   EnvData = EnvData & "HTTP_REFERER=" & Referer & $Nul
   EnvData = EnvData & "HTTP_CONNECTION=" & Connection & $Nul
   EnvData = EnvData & "HTTP_FROM=" & $Nul
   EnvData = EnvData & "HTTP_COOKIE=" & $Nul
   EnvData = EnvData & "HTTP_HOST=" & LocalHost & $Nul
   EnvData = EnvData & "HTTP_PRAGMA=" & $Nul
   EnvData = EnvData & "HTTPS=" & $Nul
   EnvData = EnvData & "DOCUMENT=" & $Nul
   EnvData = EnvData & "DOCUMENT_URI=" & $Nul
   EnvData = EnvData & "DATE_GMT=" & $Nul
   EnvData = EnvData & "DATE_LOCAL=" & Date$ & $Nul
   EnvData = EnvData & "LAST_MODIFIED=" & $Nul
   EnvData = EnvData & "LOCAL_ADDR=" & LocalHost & $Nul
   EnvData = EnvData & "LOGON_USER=" & $Nul
   EnvData = EnvData & "SCRIPT_NAME=" & $Nul
   EnvData = EnvData & "SERVER_PORT_SECURE=" & $Nul
   EnvData = EnvData & $Nul & $Nul
   Function = EnvData
End Function

#If 0
' Function Not Used
Function GetTmpFileName(sPrefix As String, sPath As String) As String
   Local Prefix        As Asciiz * 25
   Local Path          As Asciiz * %MAX_PATH
   Local sNewFileName  As Asciiz * %MAX_PATH
   Local Result        As Long
   Local Unique        As Long

   If Len(sPrefix) = 0 Then
      sPrefix = "WebSrv"
   End If
   If Len(sPath) = 0 Then
      sPath = "C:\"
   End If
   Path = sPath
   Prefix = sPrefix
   sNewFileName = Space$(Len(sNewFilename))
   Unique = 0
   ' Let Windows create a unique temp file name
   Result = GetTempFileName(Path, Prefix, Unique, sNewFileName)
   If Result = 0 Then
      Function = ""
   Else
      Function = Trim$(sNewFileName)
   End If
End Function

#EndIf

Function ParseCmd(sCmd As String, Offset As Long) As String
   Local Snippet  As String
   Local Cmd      As String

   Cmd = sCmd
   Snippet = Mid$(Cmd, Offset)
   ' Did we get a page?
   If InStr(Cmd, " ") Then
      ' Take everything up to the first space
      Snippet = Left$(Snippet, InStr(Snippet, " ") - 1)
   End If
   ' filter space chars for long file names
   Replace "%20" With " " In Snippet
   ' Trim off leading and trailing spaces
   Snippet = Trim$(Snippet)
   ' Check for / or \ only
   If Snippet = "/" Or Snippet = "\" Then
      Snippet = gCfg.IndexFl
   End If
   ' change unix style slashes
   Replace "/" With "\" In Snippet
   ' use current dir as root
   If Left$(Snippet, 1) = "\" Then
      Snippet = Mid$(Snippet, 2)
   End If
   ' See if it exists
   If Len(Dir$(WebDir & Snippet)) = 0 Then
      ' File not found, assume a directory
      Snippet = Snippet & "\"
      If Len(Dir$(WebDir & Snippet & "NUL")) = 0 Then
         'Nope Not a directory...  remove the backslash
         Snippet = Left$(Snippet, Len(Snippet)-1)
      End If
   End If
   ' If it ends in \ then append default
   If Right$(Snippet, 1) = "\" Then
      Snippet = Snippet + gCfg.IndexFl
   End If
   ' Default to .html extension
   If InStr(Snippet, ".") = 0 Then
      Snippet = Snippet + ".html"
   End If
   Function = Snippet
End Function

Function TodaysLogFile As String

   Local sWork   As String
   Local OutFile As String
   sWork = Date$

   ' Build a filename based on the date in yyyymmdd format.
   OutFile = Mid$(sWork,7) & Mid$(sWork,1,2) & Mid$(sWork,4,2) & ".html"
   If Len(gCfg.LogDir) Then
      ' See if LOG file dir has a trailing back-slash
      If Right$(gCfg.LogDir,1) = "\" Then
         OutFile = Trim$(gCfg.LogDir) & OutFile
      Else
         ' if not add it
         OutFile = Trim$(gCfg.LogDir) & "\" & OutFile
      End If
   End If

   Function = OutFile

End Function

Function ExecCGI(CGIExe As String, CGICmdLine As String, EnvData As String, ProcID As Long) As String

   Local StartInfo             As STARTUPINFO
   Local NewProcStartInfo      As STARTUPINFO
   Local ProcInfo              As PROCESS_INFORMATION
   Local SecAttrib             As SECURITY_ATTRIBUTES
   Local StdInFile             As String
   Local StdOutFile            As String
   Local StdErrFile            As String
   Local hStdOutput            As Long
   Local hStdInput             As Long
   Local hStdErr               As Long
   Local Result                As Long
   Local HTML                  As String
   Local PathToCGI             As String
   Local sWork                 As String

   ' Set the TempFilenames
   StdErrFile = CGIDir & "WebSrvErr" & Format$(ProcID) & ".TMP"
   StdInFile = CGIDir & "WebSrvIn" & Format$(ProcID) & ".TMP"
   StdOutFile = CGIDir & "WebSrvOut" & Format$(ProcID) & ".TMP"

   hStdOutPut = RedirectIO(StdOutFile, %False)
   hStdInPut = RedirectIO(StdInFile, %False)
   hStdErr = RedirectIO(StdErrFile, %False)

   ' Get the information for this application
   GetStartupInfo StartInfo

   ' Setup the startup info for the CGI application
   NewProcStartInfo.cb          = SizeOf (NewProcStartInfo)
   NewProcStartInfo.dwFlags     = %STARTF_USESTDHANDLES
   NewProcStartInfo.wShowWindow = %NULL
   NewProcStartInfo.hStdInput   = hStdOutPut
   NewProcStartInfo.hStdOutput  = hStdInPut
   NewProcStartInfo.hStdError   = hStdErr
   NewProcStartInfo.lpTitle     = %NULL

   ' What is the length of the structure
   SecAttrib.nLength = SizeOf(SecAttrib)
   ' What security descriptor do we use. NONE
   SecAttrib.lpSecurityDescriptor = %NULL
   ' Cause the new process to inherit its Standard IO from this process
   SecAttrib.bInheritHandle = %True

   ProcInfo.hProcess = %NULL

   StdOutLn hStdOutPut, CGICmdLine
   Sleep 50

   ' Check for Pathname already in CGI EXE NAME

   If InStr(CGIExe, "/") Then
      Replace "/" With "\" In CGIExe
   End If

   If InStr(CGIExe, "\") Then
      ' Pathname is in the CGI FileName Already!!
      ' extract the filename to sWork
      sWork = Extract$(CGIExe,"\")
      ' Path will be the remainder of CGIExe!
      PathToCGI = Left$(CGIExe, Len(CGIExe)-Len(sWork))
      CGIExe = sWork
   Else
      PathToCGI = CGIDir
   End If

   ' Create the CGI process
   Result = CreateProcess(PathToCGI & CGIExe, CGIExe & " " & CGICmdLine, SecAttrib, SecAttrib, %True, %DETACHED_PROCESS, ByCopy EnvData, ByCopy PathToCGI, NewProcStartInfo, ProcInfo)
   If ProcInfo.hProcess = 0 Then
      HTML = "<P>Process failed to start.</p>" + $Cr
      HTML = HTML + "<p>CGIDir: " + CGIDir + "</p>" + $Cr
      HTML = HTML + "<p>CGIExe: " + CGIExe + "</p>" + $Cr
   Else
      ' Wait for 10 seconds and see if the process completes
      WaitForSingleObject ProcInfo.hProcess, 10000

      HTML = ""
      CloseHandle ProcInfo.hThread
      CloseHandle ProcInfo.hProcess
   End If

   ReleaseRedirectIO hStdInPut
   ReleaseRedirectIO hStdOutPut
   ReleaseRedirectIO hStdErr

   If Len(HTML) = 0 Then
      hStdInPut = FreeFile
      Open StdInFile For Binary Access Read Write Shared As hStdInPut
      If Lof(hStdInPut) Then
         Get$ hStdInPut, Lof(hStdInPut), HTML
      End If
      Close hStdInPut
   End If

   Sleep 100

   Kill StdErrFile
   Kill StdInFile
   Kill StdOutFile

   Function = HTML

End Function

Function GetIncludeFile(File As String) As String

   Local hFile As Long
   Local Buff  As String

   If Len(Dir$(File)) Then
      hFile = FreeFile
      Open File For Binary Access Read Shared As hFile
      If ErrClear Then
         Close hFile
         Function = "ERROR Opening file: " & File
         Exit Function
      End If
      Buff = Space$(Lof(hFile))
      Get$ hFile, Lof(hFile), Buff
      Close hFile
   End If

   ' Apply some fix-up's for TXT type files to be viewed
   ' in HTML format.
   Replace "&"   With "&amp;" In Buff
   Replace ""   With "&copy;" In Buff
   Replace $CrLf With "<br>" In Buff
   Replace "  "  With " &nbsp;" In Buff

   Function = Buff

End Function

Function ProcessHTML(HTML As String, ID As Long, EnvData As String, ReqData As String) As String

   Local Count     As Dword
   Local NewHTML   As String
   Local sWork     As String
   Local sTemp     As String
   Local CGIExe    As String
   Local ExtraData As String
   Local Snippet   As String
   Local pHTML     As Byte Ptr
   Local x         As Dword
   Local i         As Dword
   Local CurrPos   As Dword
   Local StartPos  As Dword
   Local EndPos    As Dword
   Local Pass      As Dword

   Count = Tally(HTML, "<!-- #")

   ' If No SSI Commands or SSI is disabled then get out!
   If Count = 0 Or Bit(gCfg.Flag,1) = 0 Then
      Function = HTML
      Exit Function
   End If

   NewHTML = ""

   For Pass = 1 To Count

       CurrPos = InStr(HTML, "<!-- #")
       StartPos = CurrPos

       'Move Non-SSI Code into output buffer
       If CurrPos > 1 Then
          NewHTML = NewHTML & Left$(HTML,CurrPos-1)
       End If

       pHTML = StrPtr(HTML)

       ' Strip Out the SSI Command
       For x = CurrPos-1 To Len(HTML)-1
           sTemp = Chr$(@pHTML[x])
           If sTemp = ">" Then
              sWork = sWork & sTemp
              Exit For
           End If
           sWork = sWork & sTemp
       Next x

       ' Save the original Snippet in case it's something
       ' we cannot use, then we will replace it.
       Snippet = sWork

       ' +2 because x is 0 indexed!
       EndPos = x + 2

       ' Clear the original buffer of stuff we already
       ' processed
       HTML = Mid$(HTML, EndPos)
       StartPos = 0: EndPos = 0

       ' prep for Evaluations
       sWork = Mid$(sWork, 5)
       sWork = Trim$(LCase$(sWork))

       If Left$(sWork,10) = "#exec cgi=" Then
          ' Start at Pos 12 to skip the quote mark!
          sWork = Mid$(sWork,12)
          ' get the ending quote mark pos
          CurrPos = InStr(sWork, Chr$(34))
          If CurrPos Then
             sWork = Left$(sWork,CurrPos-1)
          Else
             ' Replace Snippet, it wasn't for us!
             NewHTML = NewHTML & Snippet
             sWork = ""
             Iterate For
          End If

          If InStr(sWork,"?") Then
             CGIExe = Extract$(sWork,"?")
             ExtraData = Remain$(sWork,"?")
           Else
             CGIExe = sWork
             ExtraData = ""
          End If

          sWork = ExecCGI(CGIExe, ExtraData, EnvData, ID)

          NewHTML = NewHTML & sWork

          sWork = ""
       ElseIf Left$(sWork,6) = "#debug" Then
          sWork = "<h1 align=""center"">Server Name: " & Trim$(gCfg.SrvNam) & "</h1>" & $CrLf
          sWork = sWork & "<h2 align=""center"">Debug Information</h2>" & $CrLf
          sWork = sWork & "<p> Server Root = " & Trim$(gCfg.RootDir) & "</p>"
          sWork = sWork & "<p> CGI Directory = " & Trim$(gCfg.CGIDir) & "</p>"

          If Bit(gCfg.Flag,2) Then
             sWork = sWork & "<p> Server Security is <strong>Enabled</strong>.</p>" & $CrLf
             sWork = sWork & "<p> Number of Secure Directories is " & Format$(DirRecs)
             sWork = sWork & "<br>Secure Directories:<br>" & $CrLf
             For i = 1 To DirRecs
                 sWork = sWork & "&nbsp; &nbsp; &nbsp; " & WebDir & Dirs(i).DirName & "<br>" & $CrLf
             Next i
             sWork = sWork & "</p>"
          Else
             sWork = sWork & "<p> Server Security is <strong>Disabled</strong>.</p>" & $CrLf
          End If

          sWork = sWork & "<p> Maximum Connects = " & Format$(gCfg.MaxConn) & "</p>"
          sWork = sWork & "<p>&nbsp; </p>"
          NewHTML = NewHTML & sWork & ReqData
          sWork = ""
       ElseIf Left$(sWork,9) = "#include=" Then
          ' Start at Pos 11 to skip the quote mark!
          sWork = Mid$(sWork,11)
          ' get the ending quote mark pos
          CurrPos = InStr(sWork, Chr$(34))
          If CurrPos Then
             sWork = Left$(sWork,CurrPos-1)
          Else
             ' Replace Snippet, it wasn't for us!
             NewHTML = NewHTML & Snippet
             sWork = ""
             Iterate For
          End If
          sWork = GetIncludeFile(sWork)
          NewHTML = NewHTML & sWork

          sWork = ""
       Else
          ' Replace Snippet, it wasn't for us!
          NewHTML = NewHTML & Snippet
          sWork = ""
       End If

   Next Pass

   ' Add the Remaining Code to our output
   NewHTML = NewHTML & HTML

   Function = NewHTML

End Function

' Check a user/PW combination for access to a given directory.
'
Function SecurityCheck(USR As String, PW As String, Snippet As String) As Long

   Local idx   As Long
   Local i     As Long
   Local count As Long
   Local sWork As String

   ' No users on file so exit
   If UsrRecs = 0 Then Exit Function


   ' First Find the User
   For idx = 1 To UsrRecs
       If User(idx).UserName = USR Then Exit For
   Next idx
   If idx > UsrRecs Then Exit Function  ' User not found!

   If User(idx).UserExp Then  ' Expiration Date is set
      If DateToDays(Date$) >= User(idx).UserExp Then
         Exit Function        ' Account Has Expired!
      End If
   End If

   ' Next check the users Password
   If PW <> User(idx).UserPW Then Exit Function

   ' get the count of how many directories user has access to
   count = ParseCount(User(idx).UserDirs,",")

   ' if he has none get out.
   If count = 0 Then Exit Function

   ' See if user has access to the current directory request
   For i = 1 To count
       sWork = UCase$(Parse$(User(idx).UserDirs,",",i) & "\")
       If sWork = UCase$(Left$(Snippet, Len(sWork))) Then
          Function = 1  ' User has the directory so security
          Exit Function ' check passed
       End If
   Next i

End Function

' Is the current directory request a secured directory?
'
Function IsSecureDir(Snippet As String) As Long

   Local idx   As Long
   Local sWork As String

   If DirRecs = 0 Then Exit Function
   For idx = 1 To DirRecs
       sWork = UCase$(WebDir & Dirs(idx).DirName & "\")
       If sWork = UCase$(Left$(WebDir & Snippet, Len(sWork))) Then
          Function = 1
          Exit Function
       End If
   Next idx
End Function

' Main Entry Point for Web Server Calls
'
' **********************************************************
Function SocketThread(ByVal ID As Long) As Long

   Local ClientRequest     As String
   Local Buffer            As String
   Local InBuffer          As String
   Local Cmd               As String
   Local Snippet           As String
   Local Extension         As String
   Local ContentType       As String
   Local HTML              As String
   Local HEADER            As String
   Local Accepts           As String
   Local AcceptEncoding    As String
   Local AcceptLanguage    As String
   Local Referer           As String
   Local UserAgent         As String
   Local Connection        As String
   Local RespConn          As String
   Local ClientHost        As String
   Local HTTPVer           As String
   Local Authorization     As String
   Local RequestType       As String
   Local EnvData           As String
   Local ExtraData         As String
   Local CGIExe            As String
   Local PW                As String
   Local USR               As String
   Local ReqData           As String
   Local sWork             As String
   Local iWork             As Long
   Local ExtraDataCount    As Long
   Local FileNum           As Long
   Local Result            As Long
   Local ContentLength     As Long
   Local hTimer            As Long
   Local AliveTime         As Dword
   Local Executable        As Integer
   Local B64InBuff         As Asciiz * 128
   Local B64OutBuff        As Asciiz * 128

   ' Keep going until a TCP_CLOSE changes the
   ' INUSE flag to 3.

   Do
      If Connections(ID).InUse <> 1 Then Exit Loop
      'release CPU time
      Sleep 50

      ' See if there is anything coming in
      Tcp Recv Connections(ID).hSocket,1024, ClientRequest

      ' Did we get something
      If Len(ClientRequest) > 0 Then
         ' Reset our Keep Alive Timer
         AliveTime = 0

         ' Get rid of any bad charactors
         ClientRequest = Remove$(ClientRequest, Any BADCHARS)

         ' filter out crlf pairs, make them cr
         Replace Chr$(13,10) With Chr$(13) In ClientRequest

         ' remove any double slashes or backslashes (Security)
         ' Begin Security Fixups
         Replace "\"  With "/" In ClientRequest

         ' First change any ./ to just a /
         While InStr(ClientRequest,"./")
            Replace "./" With "/" In ClientRequest
         Wend

         ' Next change any /. to just a /
         While InStr(ClientRequest,"/.")
            Replace "/." With "/" In ClientRequest
         Wend

         ' Finally, Remove any double slashes...
         While InStr(ClientRequest,"//")
            Replace "//" With "/" In ClientRequest
         Wend

         ' Append the newly recieved info to the buffer
         InBuffer = InBuffer & ClientRequest

         Do While InStr(InBuffer, Chr$(13))

            ' Release the CPU for a short while
            Sleep 1

            ' Get rid of bad influences
            InBuffer = Remove$(InBuffer, Any BADCHARS )

            ' Get the first comand from the buffer
            Cmd = Trim$(Left$(InBuffer, InStr(InBuffer, Chr$(13)) - 1))

            ' Strip the command off of the buffer
            InBuffer = Mid$(InBuffer, InStr(InBuffer, Chr$(13)) + 1)

            If UCase$(Left$(Cmd, 3)) = "GET" Or UCase$(Left$(Cmd, 3)) = "PUT" Or UCase$(Left$(Cmd, 4)) = "HEAD" Then
               'GET /page.htm HTTP/1.x    If this is CGI it could be GET /page.htm?Fld=data&Fld=data etc..
               Snippet = ParseCmd(Cmd, 5)

               ' Get the request extension
               Extension = GetExt(Snippet)

               ' Get the HTTP version from the client request
               HTTPVer = GetHTTPVer(Snippet)

               ' Get the other info pasted in
               ExtraDataCount = GetCGIData(Snippet, ExtraData, CGIExe)

               ' Get the content type for the request
               ContentType = GetContentType(Extension, Executable)

               RequestType = "GET"

            ElseIf UCase$(Left$(Cmd, 4)) = "POST" Then
               'POST /page.htm HTTP/1.x    If this is CGI it could be POST /page.htm?Fld=data&Fld=data etc..
               Snippet = ParseCmd(Cmd, 6)

               ' Get the request extension
               Extension = GetExt(Snippet)

               ' Get the HTTP version from the client request
               HTTPVer = GetHTTPVer(Snippet)

               ' A post only has the EXE here
               CGIExe = Snippet

               ' Get the other info passed in
               'ExtraDataCount = GetCGIData(Snippet, ExtraData, CGIExe)

               ' Get the content type for the request
               ContentType = GetContentType(Extension, Executable)

               RequestType = "POST"

            ElseIf UCase$(Left$(Cmd, 7)) = "ACCEPT:" Then
               ' Get the Accept information
               Accepts = Mid$(Cmd, 8)

            ElseIf UCase$(Left$(Cmd, 16)) = "ACCEPT-LANGUAGE:" Then
               ' Get the language being requested
               AcceptLanguage = Mid$(Cmd, 17)

            ElseIf UCase$(Left$(Cmd, 16)) = "ACCEPT-ENCODING:" Then
               ' Get the encoding types supported
               AcceptEncoding = Mid$(Cmd, 17)

            ElseIf UCase$(Left$(Cmd,14)) = "AUTHORIZATION:" Then
               ' Get the UserID & Password Strings
               Authorization = Mid$(Cmd, 15)
               If UCase$(Left$(LTrim$(Authorization),5)) = "BASIC" Then
                  Authorization = Mid$(LTrim$(Authorization),6)
                  Authorization = Trim$(Authorization)
               Else
                  Authorization = ""
               End If

            ElseIf UCase$(Left$(Cmd, 11)) = "USER-AGENT:" Then
               ' Get the user agent information (Browser Type)
               UserAgent = Mid$(Cmd, 12)

            ElseIf UCase$(Left$(Cmd, 5)) = "HOST:" Then
               ' Get the Host information (Who Called Us)
               ClientHost = Mid$(Cmd, 6)

            ElseIf UCase$(Left$(Cmd, 11)) = "CONNECTION:" Then
               ' Get the connection type
               Connection = Mid$(Cmd, 12)
               If Left$(Trim$(UCase$(Connection)),10) = "KEEP-ALIVE" Then
                  RespConn = "Connection: Keep-Alive" & $CrLf
               Else
                  RespConn = "Connection: Close" & $CrLf
               End If

            ElseIf UCase$(Left$(Cmd, 8)) = "REFERER:" Then
               ' Get the referer. Who sent the user here
               Referer = Trim$(Mid$(Cmd, 9))
               If LCase$(Left$(Referer, 6)) = "http:/" Then
                  Referer = "http://" & Mid$(Referer,7)
               End If

            ElseIf InStr(UCase$(Cmd), "CONTENT-LENGTH:") > 0 Then
               ' This means that there is more data coming.
               ContentLength = GetContentLength(Cmd)
            Else
            End If

            ' CRLF on a line by itself indicates header is over

            If Cmd = "" Then
               ' Must be a CGI type request
               If IsTrue Executable Then
                  If CGIExe = "" Then
                     If InStr(Snippet,"?") Then
                        CGIExe = Extract$(Snippet,"?")
                        ExtraData = Remain$(Snippet,"?")
                     Else
                        CGIExe = Snippet
                        ExtraData = ""
                     End If
                  End If
                  If RequestType = "POST" Then
                     ' A post request puts the information at the bottom of the request
                     ' Get the extra data from the buffer
                     ExtraData = Trim$(Left$(InBuffer, InStr(InBuffer, Chr$(13)) - 1))

                     ' Strip the data off of the buffer
                     InBuffer = Mid$(InBuffer, InStr(InBuffer, Chr$(13)) + 1)

                  End If

                  ' See if the CGI is in the CGI directory
                  sWork = Dir$(Trim$(gCfg.CgiDir) & "\" & CGIExe)
                  If Len(sWork) Then  ' If so execute it

                     EnvData = SetEnvData(RequestType, ExtraData, Authorization, ClientHost, _
                                         Accepts, AcceptLanguage, AcceptEncoding, _
                                         UserAgent, Referer, Connection)

                     ' Exec the CGI
                     HTML = ExecCGI(CGIExe, ExtraData, EnvData, ID)

                  Else

                     ' Not a CGI so transfer it!
                     ContentType = "application/octet-stream"
                     Executable = %FALSE

                     FileNum = FreeFile
                     hTimer = StartTimer(60)
                     sWork = Dir$(WebDir & CGIExe)
                     iWork = ErrClear

                     If Len(sWork) Then
                        Do
                           ' If someone is using it, then wait for them
                           Open WebDir & CGIExe For Binary Shared As FileNum
                           If ErrClear Then
                              iWork = 1
                              Sleep 1000
                              Close FileNum
                           Else
                              iWork = 0
                           End If
                           If Expired(hTimer) Then
                              Exit Loop
                           End If
                           If iWork = 0 Then Exit Loop
                        Loop

                        If Expired(hTimer) Then
                           HTML = html_404error
                        Else
                           HTML = Space$(Lof(FileNum))
                           Get$ FileNum, Lof(FileNum), HTML
                           Close FileNum
                        End If
                     Else
                        HTML = html_404error
                     End If
                  End If

                  ' Create the header for this page only
                  ' if it isn't a dynamic CGI Page.

                  If Left$(HTML,5) = "HTTP/" Then
                     HEADER = ""
                  Else
                     HEADER = "HTTP/1.0 200 OK" & $CrLf
                     HEADER = HEADER & RespConn
                     HEADER = HEADER & "Server: LilHTTP/" & $StrVers & $CrLf
                     HEADER = HEADER & "Content-Type: " & ContentType & $CrLf
                     HEADER = HEADER & "Accept-Ranges: none" & $CrLf
                     HEADER = HEADER & "Content-Length: " & Format$(Len(HTML)) & $CrLf
                     HEADER = HEADER & $CrLf
                  End If

                  ' Put it all together
                  Buffer = HEADER & HTML

                  ' Send it out
                  Tcp Send Connections(ID).hSocket, Buffer

                  CGIExe = ""

                  Exit Loop

               End If

               ' Bad request so show the Error page
               If Dir$(WebDir & Snippet) = "" Then
                  HTML = html_404error
                  HEADER = "HTTP/1.0 404 FILE NOT FOUND" & $CrLf
                  HEADER = HEADER & RespConn
                  HEADER = HEADER & "Server: LilHTTP/" & $StrVers & $CrLf
                  HEADER = HEADER & "Content-Type: text/html" & $CrLf
                  HEADER = HEADER & "Accept-Ranges: none" & $CrLf
                  HEADER = HEADER & "Content-Length:" & Format$(Len(HTML)) & $CrLf
                  HEADER = HEADER & $CrLf
                  Buffer = HEADER & HTML

                  ' Send it out
                  Tcp Send Connections(ID).hSocket, Buffer
                  Exit Loop
               End If

               ' get the next file num
               FileNum = FreeFile

               ' read the page from disk into HTML$
               ' Only wait for 60 seconds
               hTimer = StartTimer(60)
               iWork = ErrClear
               Do
                  ' If someone is using it, then wait for them
                  Open WebDir & Snippet For Binary Shared As FileNum
                  If ErrClear Then
                     iWork = 1
                     Sleep 1000
                     Close FileNum
                  Else
                     iWork = 0
                  End If
                  If Expired(hTimer) Then
                     Exit Loop
                  End If
                  If iWork = 0 Then Exit Loop
               Loop

               If Expired(hTimer) Then
                  HTML = html_404error
               Else
                  HTML = Space$(Lof(FileNum))
                  Get$ FileNum, Lof(FileNum), HTML
                  Close FileNum
               End If

               If Bit(gCfg.Flag,2) Then  ' Security is enabled

                  If IsSecureDir(Snippet) Then
                     ' Security Check Needed!
                     If Len(Authorization) Then
                        B64InBuff = Authorization
                        Base64Dec B64InBuff, B64OutBuff, SizeOf(B64OutBuff)
                        USR = Extract$(B64OutBuff,":")
                        PW = Remain$(B64OutBuff,":")
                        If SecurityCheck(USR,PW,Snippet)=0 Then
                           RespConn = ""  ' Destroy Connection
                           HTML = html_401error
                           HEADER = "HTTP/1.0 401 UNAUTHORIZED" & $CrLf
                           HEADER = HEADER & "Server: LilHTTP/" & $StrVers & $CrLf
                           HEADER = HEADER & "Content-Type: text/html" & $CrLf
                           HEADER = HEADER & "Accept-Ranges: none & $CRLF
                           HEADER = HEADER & "Content-Length: " & Format$(Len(HTML)) & $CrLf
                           HEADER = HEADER & "WWW-Authenticate: Basic realm=" & Chr$(34) & "LilHTTP" & Chr$(34) & $CrLf
                           HEADER = HEADER & $CrLf
                           ' Put it all together
                           Buffer = HEADER & HTML

                           ' Send it out
                           Tcp Send Connections(ID).hSocket, Buffer

                           Exit Loop
                        End If
                     Else
                        ' Security
                        RespConn = ""  ' Destroy Connection
                        HTML = html_401error
                        HEADER = "HTTP/1.0 401 UNAUTHORIZED" & $CrLf
                        HEADER = HEADER & "Server: LilHTTP/" & $StrVers & $CrLf
                        HEADER = HEADER & "Content-Type: text/html" & $CrLf
                        HEADER = HEADER & "Accept-Ranges: none" & $CrLf
                        HEADER = HEADER & "Content-Length: " & Format$(Len(HTML)) & $CrLf
                        HEADER = HEADER & "WWW-Authenticate: Basic realm=" & Chr$(34) & "LilHTTP" & Chr$(34) & $CrLf
                        HEADER = HEADER & $CrLf
                        ' Put it all together
                        Buffer = HEADER & HTML

                        ' Send it out
                        Tcp Send Connections(ID).hSocket, Buffer

                        Exit Loop
                     End If
                  End If

               End If

               EnvData = SetEnvData(RequestType, ExtraData, Authorization, ClientHost, _
                                   Accepts, AcceptLanguage, AcceptEncoding, _
                                   UserAgent, Referer, Connection)

               ReqData = SetReqData(RequestType, Accepts, AcceptLanguage, _
                                    AcceptEncoding, Authorization, UserAgent, _
                                    ClientHost, Connection, Referer, ContentLength)

               HTML = ProcessHTML(HTML, ID, EnvData, ReqData)

               ' Create the header for this page Any CGI
               ' at this point will be imbedded via SSI.

               HEADER = "HTTP/1.0 200 OK" & $CrLf
               HEADER = HEADER & RespConn
               HEADER = HEADER & "Server: LilHTTP/" & $StrVers & $CrLf
               HEADER = HEADER & "Content-Type: " & ContentType & $CrLf
               HEADER = HEADER & "Accept-Ranges: none" & $CrLf
               HEADER = HEADER & "Content-Length: " & Format$(Len(HTML)) & $CrLf
               HEADER = HEADER & $CrLf
               ' Put it all together
               Buffer = HEADER & HTML

               ' Send it out
               Tcp Send Connections(ID).hSocket, Buffer

               If Bit(gCfg.Flag,4) Then  ' Logging is ON
                  If Bit(gCfg.Flag,5) Then ' Text/HTML ONLY!
                     If InStr(ContentType, "text") = 0 Then
                        Exit Loop
                     ElseIf IsTrue Executable Then
                        Exit Loop
                     End If
                  End If
                  ' Ok To Log from here!
                  HTML = "--> " & Time$ & "  " & Date$ & "<br>
                  If Len(USR) Then
                     HTML = HTML & "User ID: <b>" & USR & "</b><br>"
                  End If
                  If Len(ClientHost) Then
                     HTML = HTML & "Reported Host: <b>" & ClientHost & "</b><br>
                  End If
                  Result = Connections(ID).hSocket
                  iWork  = TcpAddr(Result)
                  Host Name iWork To sWork
                  If Len(sWork) Then
                     HTML = HTML & "Actual IP: <b>" & IpToString(iWork) & " (" & sWork & ")</b><br>"
                  Else
                     HTML = HTML & "Actual IP: <b>" & IpToString(iWork) & "</b><br>"
                  End If
                  HTML = HTML & "Requested Page: <b>" & Snippet & "</b><br>"
                  If Len(Referer) Then
                     HTML = HTML & "Refered From: <b>" & Referer & "</b><br>"
                  End If
                  HTML = HTML & "User Agent: <b>" & UserAgent & "</b><hr>"

                  FileNum = FreeFile

                  ' Only try writing to this file for
                  ' 20 Seconds Otherwise bail out.
                  hTimer = StartTimer(20)
                  iWork = ErrClear ' Clear any existing err codes

                  Do
                     ' If someone is using it, then wait for them
                     Open TodaysLogFile For Append As FileNum
                     If ErrClear Then
                        Sleep 1000
                        Close FileNum
                        iWork = 1
                     Else
                        iWork = 0
                     End If
                     If Expired(hTimer) Then
                        Exit Loop
                     End If
                     If iWork = 0 Then Exit Loop
                  Loop

                  If iWork = 0 Then
                     Print# FileNum, HTML
                     Close FileNum
                  End If

               End If

               Exit Loop
            End If

         Loop
      End If

      If InStr(RespConn,"Close") Then
         Exit Loop
      ElseIf Len(RespConn)=0 Then
         Exit Loop
      End If

      Incr AliveTime  ' Increment Our Live Timer

      If AliveTime > 100 Then  ' If we're Idle for more than
         Exit Loop             ' 5 min (300 secs) close the connection
      End If                   ' TimeOut = 3 Secs + 50ms Sleep

      ' Reset Critical Variables Here?   eg. Keep-Alive, Content, etc.

   Loop

   ' Close the socket
   Tcp Close Connections(ID).hSocket

   Connections(ID).InUse = 2   '<-- We're done with it
   Function = 2    '<-- To show we are done!

End Function

' Display Thread Status for Current Threads
'
CallBack Function ThreadStatus As Long

   Local i    As Long
   Local Idle As Long
   Local Rng  As Long
   Local ITz  As Long

   If CbCtlMsg = %STN_DBLCLK Then
      For i = 1 To gCfg.MaxConn
          If Connections(i).InUse = 1 Then
             Incr Rng
          ElseIf Connections(i).InUse = 2 Then
             Incr Idle
          ElseIf Connections(i).InUse = 3 Then
             Incr ITz
          End If
      Next i
      MsgBox Format$(Rng) & " Threads are running" & $Cr & _
             Format$(ITz) & " Threads are shutting down" & $Cr & _
             Format$(Idle) & " Threads are idle (awaiting cleanup)",,"Thread Status"
   End If

End Function

' Clean UP Idle Threads This function is called by
' a timer control.
'
CallBack Function CleanUpThreads As Long

   Local i   As Long
   Local ts  As Long
   Local cn  As Long

   If CbCtl <> 400 Then Exit Function

   ' Timer got us here!
   'Kill Any Finished Threads....
   For i = 1 To gCfg.MaxConn
       If Connections(i).InUse = 2 Then
          Thread Status Connections(i).hThread To ts
          If ts = 2 Then
             Thread Close Connections(i).hThread To ts
             If ts Then
                Connections(i).hSocket = 0
                Connections(i).hThread = 0
                Connections(i).InUse = 0
             End If
          ElseIf ts = &H103 Then
             Thread Suspend Connections(i).hThread To ts
             If ts <> -1 Then
                Thread Close Connections(i).hThread To ts
                If ts Then
                   Tcp Close Connections(i).hSocket
                   Connections(i).hSocket = 0
                   Connections(i).hThread = 0
                   Connections(i).InUse = 0
                End If
             End If
          End If
       ElseIf Connections(i).InUse = 1 Then
          Incr cn
       End If
   Next i

   Control Set Text hDlg, 1500, Format$(cn)

End Function

Sub SplitPath (Source As String, Fldrive As String, _
              Flpath As String, Flname As String)

   Dim StartPos As Integer
   Dim x        As Integer

   StartPos = 0

   If Mid$(Source, 2, 1) = ":" Then
      Fldrive = Left$(Source, 2)
      Source = Mid$(Source, 3)
   End If

   For x = Len(Source$) To 1 Step -1
       If Mid$(Source$, x, 1) = "\" Then
          StartPos = x
          Exit For
       End If
   Next

   Flname = Right$(Source, (Len(Source) - StartPos))

   If StartPos > 0 Then
      Flpath = Left$(Source, StartPos)
   End If

End Sub

Function GetDataPath() As String

   Local fullpath As Asciiz * 128
   Local source   As String
   Local drive    As String
   Local path     As String
   Local exefile  As String

   GetModuleFilename %NULL, fullpath, SizeOf(fullpath)
   source = fullpath
   SplitPath source, drive, path, exefile
   Function = drive & path

End Function

'---  Begin Tool Tips Code --------------------------------

#If Not %Def(%TTS_ALWAYSTIP)
%TTS_ALWAYSTIP      = &H01
%TTF_IDISHWND       = &H0001
%TTF_SUBCLASS       = &H0010
%TTM_ADDTOOL        = %WM_USER + 4
%TTM_GETTOOLINFO    = %WM_USER + 8
%TTM_DELTOOL        = %WM_USER + 5
#EndIf

Function ToolTip_Create(ByVal hWnd As Long) As Long

   If hWnd_ToolTip = 0 Then
      If hWnd = 0 Then hWnd = GetActiveWindow()
      If hWnd = 0 Then Exit Function
      hWnd_ToolTip = CreateWindowEx(0 _
          , "tooltips_class32" _
          , "" _
          , %TTS_ALWAYSTIP  Or %TTS_BALLOON _
          , 0 _
          , 0 _
          , 0 _
          , 0 _
          , hWnd _
          , ByVal 0& _
          , GetWindowLong(hWnd, %GWL_HINSTANCE) _
          , ByVal 0&)
   End If

   Function = hWnd_ToolTip

End Function

#If 0
' Function Not Used
Function ToolTip_Destroy() As Long

   If hWnd_ToolTip Then DestroyWindow hWnd_ToolTip
   hWnd_ToolTip = 0

End Function

#EndIf

Function SetToolTip(ByVal hWnd As Long, ByVal Txt As String) As Long

   Local tinf As TOOLINFO

   If ToolTip_Create(GetParent(hWnd)) = 0 Then Exit Function

   tinf.cbSize   = Len(tinf)
   tinf.uFlags   = %TTF_SUBCLASS Or %TTF_IDISHWND
   tinf.hWnd     = GetParent(hWnd)
   tinf.uId      = hWnd

   If SendMessage(hWnd_ToolTip, %TTM_GETTOOLINFO, 0, ByVal VarPtr(tinf)) Then
      Call SendMessage(hWnd_ToolTip, %TTM_DELTOOL, 0, ByVal VarPtr(tinf))
   End If

   tinf.cbSize   = Len(tinf)
   tinf.uFlags   = %TTF_SUBCLASS Or %TTF_IDISHWND
   tinf.hWnd     = GetParent(hWnd)
   tinf.uId      = hWnd
   tinf.lpszText = StrPtr(Txt)

   Function = SendMessage(hWnd_ToolTip, %TTM_ADDTOOL, 0, ByVal VarPtr(tinf))

End Function

'---  End Tool Tips Code ----------------------------------

CallBack Function WebbSubclass

   Select Case CbMsg
      Case %WM_MOUSEMOVE
         If CursorHand = 0 Then
            SetClassLong CbHndl, %GCL_HCURSOR, LoadCursor(0, ByVal %IDC_HAND)
            CursorHand = -1
         End If

      Case Else
         Function = CallWindowProc(OldWebProc1, CbHndl, CbMsg, CbWParam, CbLParam)

   End Select

End Function

Sub GotoUrl(url As Asciiz)
   Local uRes As Long
   Local Msg  As Asciiz * 127

   uRes = ShellExecute(0, "", url, "", "", %SW_SHOWNORMAL)
   If uRes <= 32 Then
      Msg = "Could not start any web-browser." & $CrLf
      Msg = Msg & "Please make sure a browser is properly installed and try again."
      MessageBox hDlg, Msg, "No browser found!" & Chr$(0), %MB_ICONEXCLAMATION
   End If

End Sub

Function MakeFont(ByVal sFont As String, ByVal PointSize As Long) As Long

   Local hDC      As Long
   Local CyPixels As Long

   hDC = GetDC(%HWND_DESKTOP)
   CyPixels  = GetDeviceCaps(hDC, %LOGPIXELSY)
   ReleaseDC %HWND_DESKTOP, hDC

   PointSize = (PointSize * CyPixels) \ 72

   Function = CreateFont(0 - PointSize, 0, 0, 0, %FW_NORMAL, 0, 0, 0, _
             %ANSI_CHARSET, %OUT_TT_PRECIS, %CLIP_DEFAULT_PRECIS, _
             %DEFAULT_QUALITY, %FF_DONTCARE, ByCopy sFont)

End Function

CallBack Function AbtDlgProc

   Local lParam As Long
   Local wParam As Long
   Local wMsg   As Long
   Local hInst  As Long
   Local url    As Asciiz * 127

   lParam  = CbLParam
   wParam  = CbWParam
   wMsg    = CbMsg
   hInst   = GetWindowLong(aDlg, %GWL_HINSTANCE)

   Select Case wMsg

     Case %WM_INITDIALOG

       Static hBrushYellow As Long, tooltipBrush As Long
       Static tFont1 As Long, tFont2 As Long, hCtl As Long
       Static haIco As Long
       Local Lb As LOGBRUSH, lf As LOGFONT

       haIco = LoadIcon(hInst, "APP_ICON")
       If haIco Then Dialog Send aDlg, %WM_SETICON, %ICON_BIG, haIco

       'Init Web Sub-Class
       Control Handle aDlg, 600 To hCtl
       oldWebproc1 = SetWindowLong(hCtl, %GWL_WNDPROC, CodePtr(WebbSubclass))

       'Set labels
       Lb.lbStyle  = %WHITE_BRUSH
       Lb.lbColor  = RGB(255, 255, 239)                  'Light yellow color
       hBrushYellow = CreateBrushIndirect(Lb)            'Create a brush for color
       Lb.lbColor  = RGB(239, 255, 239)                  'Tool tip brush
       tooltipBrush = CreateBrushIndirect(Lb)            'Create a brush for tooltip color

       tFont2 = MakeFont("MS Sans Serif", 14)             'Create font handle
       tFont1 = MakeFont("MS Sans Serif", 8)
       If tFont2 <> %NULL Then
          GetObject tFont2, SizeOf(lf), ByVal VarPtr(lf)
          lf.lfWeight = %FW_BOLD                         'Font bold
          tFont2 = CreateFontIndirect(lf)
          Control Send aDlg, 300, %WM_SETFONT, tFont2, 1
          GetObject tFont1, SizeOf(lf), ByVal VarPtr(lf)
          lf.lfWeight = %FW_BOLD
          lf.lfUnderline = -1
          tFont1 = CreateFontIndirect(lf)
          Control Send aDlg, 600, %WM_SETFONT, tFont1, 1
       End If

       Function = 1

     Case %WM_CTLCOLORSTATIC   'this is where Back color painting, etc, happens
        Select Case GetDlgCtrlID(CbLParam)
           Case aDlg
              SetBkMode CbWParam, %TRANSPARENT                'make it transparent
              Function = tooltipBrush  'return handle, to set the background color

           Case 600, 500, 400, 300, 200, 100

              SetBkMode CbWParam, %TRANSPARENT                  'make it transparent

              Select Case GetDlgCtrlID(CbLParam)                'For text colors
                 Case 600    'Blue text color
                    SetTextColor CbWParam, RGB(0, 0, 196)

                 Case 300
                    SetTextColor CbWParam, RGB(128, 0, 0)       'Red text color
              End Select

              Function = hBrushYellow  'return handle, to set the background color
              Exit Function
        End Select

     Case %WM_MOUSEMOVE           'reset Hand-like mouse pointer in url labels
        If CursorHand Then
           SetClassLong GetDlgItem(CbHndl, 600), %GCL_HCURSOR, _
                       LoadCursor(0, ByVal %IDC_ARROW)
           CursorHand = 0
        End If

     Case %WM_DESTROY

        If tFont1       Then DeleteObject tFont1
        If tFont2       Then DeleteObject tFont2
        If hBrushYellow Then DeleteObject hBrushYellow
        If tooltipBrush Then DeleteObject tooltipBrush
        If haIco        Then DeleteObject haIco
        If oldWebproc1  Then SetWindowLong hCtl, %GWL_WNDPROC, oldWebproc1
        aDlg = 0

     Case %WM_COMMAND
        Select Case LoWrd(wParam)

          Case 600
             If HiWrd(CbWParam) = %STN_CLICKED Then      '<- Clicked on URL label
                url = "http://www.summitcn.com"
                GotoUrl url
                Function = 0
             End If

          Case %IDOK
            ' ** Close Window
             If CbCtlMsg=%BN_CLICKED Then
                Dialog End CbHndl, 0
             End If

        End Select

   End Select

End Function

Sub AboutProgram
   #Register None

   Local CAP1   As String
   Local CAP2   As String
   Local CAP3   As String
   Local URL1   As String
   Local title  As String

   If aDlg Then Exit Sub

   title = "Lil' HTTP Server v" & $StrVers

   Dialog New hDlg,title,,, 250, 105, _
                      %DS_CENTER Or _
                      %WS_MINIMIZEBOX Or _
                      %WS_SYSMENU, _
                      %WS_EX_CLIENTEDGE _
                      To aDlg

   CAP1 = "Lil' HTTP Server"
   CAP2 = "By Summit Computer Networks, and Scott Slater" & $CrLf
   CAP3 = "Freeware HTTP Server version " & $StrVers
   CAP3 = CAP3 & ""
   CAP3 = CAP3 & " "
   URL1 = "www.summitcn.com"

   Control Add Label,  aDlg, -1,           "",   8,  8, 233, 59, %SS_GRAYRECT
   Control Add Label,  aDlg, 100,  "",  6,  6, 234, 60, %WS_BORDER
   Control Add Image,  aDlg, 200, "APP_ICON", 12, 10,  32, 32

   Control Add Label,  aDlg, 300,  CAP1,  40,  8, 180, 20, %SS_CENTER
   Control Add Label,  aDlg, 400,  CAP2,  40, 28, 180, 10, %SS_CENTER
   Control Add Label,  aDlg, 500,  CAP3,  40, 38, 194, 25, %SS_CENTER

   Control Add Label,  aDlg, 600,  URL1,  39, 55, 175, 10, %SS_NOTIFY Or %SS_CENTER
   Control Add Button, aDlg, %IDOK, "&Close", 100, 72, 50, 15

   Dialog Show Modeless aDlg Call AbtDlgProc

End Sub

Function WriteSettings As Long

   Local hFile   As Long
   Local Recs    As Dword
   Local DPath   As String
   Local CfgFile As String
   Local UsrFile As String
   Local DirFile As String

   DPath   = GetDataPath
   CfgFile = DPath & "LilHTTP.CFG"
   UsrFile = DPath & "LilHTTP.USR"
   DirFile = DPath & "LilHTTP.DRS"

   hFile = FreeFile

   Open CfgFile For Random Access Read Write Shared As hFile _
      Len=Len(HTTPCFG)
   If ErrClear Then
      Exit Function
   End If
   Put hFile, 1, gCfg
   Close hFile

   Kill DirFile   ' Delete the File first
   If ErrClear Then
      Exit Function
   End If

   If DirRecs Then
      Open DirFile For Random Access Read Write Shared As hFile _
         Len=SizeOf(Dirs(1))
      For Recs = 1 To DirRecs
          Put hFile, Recs, Dirs(Recs)
      Next Recs
      Close hFile
   End If

   Kill UsrFile   ' Delete it first
   If ErrClear Then
      Exit Function
   End If

   If UsrRecs Then
      Open UsrFile For Random Access Read Write Shared As hFile _
         Len=Len(UserAcct)
      For Recs = 1 To UsrRecs
          Put hFile, Recs, User(Recs)
      Next Recs
      Close hFile
   End If

   Function = 1  ' Success!

End Function

Function ReadSettings As Long

   Local hFile   As Long
   Local Recs    As Dword
   Local DPath   As String
   Local CfgFile As String
   Local UsrFile As String
   Local DirFile As String

   DPath   = GetDataPath
   CfgFile = DPath & "LilHTTP.CFG"
   UsrFile = DPath & "LilHTTP.USR"
   DirFile = DPath & "LilHTTP.DRS"

   hFile = FreeFile

   Open CfgFile For Random Access Read Write Shared As hFile _
      Len=Len(HTTPCFG)
   If ErrClear Then
      Exit Function
   End If
   Recs = Lof(hFile) \ Len(HTTPCFG)
   If Recs Then
      Get hFile, 1, gCfg
   End If
   Close hFile

   If Recs = 0 Then ' Load Default Values
      gCfg.RootDir = Left$(DPath,2) & "\LILHTTP\WWWROOT"
      gCfg.CGIDir  = Left$(DPath,2) & "\LILHTTP\CGI-BIN"
      gCfg.LogDir  = Left$(DPath,2) & "\LILHTTP\WWWROOT\LOGS"
      gCfg.IndexFl = "index.html"
      gCfg.Flag    = 2  ' SSI ON All other's OFF
      gCfg.SrvNam  = "My LilHTTP Server"
      gCfg.DefPort = 80
      gCfg.IpAddr  = 16777343  ' 127.0.0.1 (LoopBack Addr)
      gCfg.MaxConn = 500
   End If

   Open DirFile For Random Access Read Write Shared As hFile _
      Len=Len(Directs)
   If ErrClear Then
      Exit Function
   End If
   DirRecs = Lof(hFile) \ Len(Directs)
   If DirRecs Then
      ReDim Dirs(1:DirRecs) As Global Directs
      For Recs = 1 To DirRecs
          Get hFile, Recs, Dirs(Recs)
      Next Recs
   Else
      ReDim Dirs(1:1) As Global directs
   End If
   Close hFile

   Open UsrFile For Random Access Read Write Shared As hFile _
      Len=Len(UserAcct)
   If ErrClear Then
      Exit Function
   End If
   UsrRecs = Lof(hFile) \ Len(UserAcct)
   If UsrRecs Then
      ReDim User(1:UsrRecs) As Global UserAcct
      For Recs = 1 To UsrRecs
          Get hFile, Recs, User(Recs)
      Next Recs
   Else
      ReDim User(1:1) As Global UserAcct
   End If
   Close hFile

   Function = 1  ' Success!

End Function

Sub FormLoad()

   Local sWork As String
   Local idx   As Dword

   ' Tab 1

   sWork = gCfg.RootDir
   Control Set Text TabNum(0), 500, sWork

   sWork = gCfg.CGIDir
   Control Set Text TabNum(0), 510, sWork

   sWork = gCfg.IndexFl
   Control Set Text TabNum(0), 520, sWork

   ' Tab 2

   sWork = Format$(gCfg.MaxConn)
   Control Set Text TabNum(1), 600, sWork

   Control Set Check TabNum(1), 605, Bit(gCfg.Flag,6)
   Control Set Check TabNum(1), 610, Bit(gCfg.Flag,1)

   sWork = Format$(gCfg.DefPort)
   Control Set Text TabNum(1), 620, sWork

   sWork = IpToString(gCfg.IpAddr)
   Control Set Text TabNum(1), 630, sWork

   sWork = gCfg.SrvNam
   Control Set Text TabNum(1), 640, sWork

   '  Tab 3
   ListBox Reset TabNum(2), 700
   If DirRecs Then
      For idx = 1 To DirRecs
          ListBox Add TabNum(2), 700, Dirs(idx).DirName
      Next idx
   End If

   '  Tab 4
   ListBox Reset TabNum(3), 800
   If UsrRecs Then
      For idx = 1 To UsrRecs
          ListBox Add TabNum(3), 800, User(idx).UserName
      Next idx
   End If

   '  Tab 5

   If Bit(gCfg.Flag,4) Then
      If Bit(gCfg.Flag,5) Then
         Control Set Check TabNum(4), 920, 1
         Control Set Check TabNum(4), 910, 0
         Control Set Check TabNum(4), 900, 0
      Else
         Control Set Check TabNum(4), 920, 0
         Control Set Check TabNum(4), 910, 1
         Control Set Check TabNum(4), 900, 0
      End If
   Else
      Control Set Check TabNum(4), 920, 0
      Control Set Check TabNum(4), 910, 0
      Control Set Check TabNum(4), 900, 1
   End If

   sWork = gCfg.LogDir
   Control Set Text TabNum(4), 930, sWork

End Sub

Sub FormSave()

   Local sWork As String
   Local iWork As Long

   ' Tab 1

   Control Get Text TabNum(0), 500 To gCfg.RootDir

   Control Get Text TabNum(0), 510 To gCfg.CGIDir

   Control Get Text TabNum(0), 520 To gCfg.IndexFl

   ' Tab 2

   Control Get Text TabNum(1), 600 To sWork
   gCfg.MaxConn = Val(sWork)
   If gCfg.MaxConn > 1000 Then gCfg.MaxConn = 500
   If gCfg.MaxConn < 50   Then gCfg.MaxConn = 500

   Control Get Check TabNum(1), 605 To iWork
   If iWork Then
      Bit Set gCfg.Flag,6
   Else
      Bit Reset gCfg.Flag,6
   End If

   Control Get Check TabNum(1), 610 To iWork
   If iWork Then
      Bit Set gCfg.Flag,1
   Else
      Bit Reset gCfg.Flag,1
   End If

   Control Get Text TabNum(1), 620 To sWork
   gCfg.DefPort = Val(sWork)
   If gCfg.DefPort < 1     Then gCfg.DefPort = 80
   If gCfg.DefPort > 65535 Then gCfg.DefPort = 80


   Control Get Text TabNum(1), 630 To sWork
   gCfg.IpAddr = StringToIp(sWork)
   If gCfg.IpAddr = 0 Then
      Host Addr To gCfg.IpAddr
      If gCfg.IpAddr = 0 Then
         gCfg.IpAddr = 16777343  ' 127.0.0.1
      End If
   End If

   Control Get Text TabNum(1), 640 To gCfg.SrvNam

   '  Tab 5

   Bit Reset gCfg.Flag,4
   Bit Reset gCfg.Flag,5

   Control Get Check TabNum(4), 920 To iWork
   If iWork Then
      Bit Set gCfg.Flag,4
      Bit Set gCfg.Flag,5
   End If

   Control Get Check TabNum(4), 910 To iWork
   If iWork Then
      Bit Set gCfg.Flag,4
   End If

   Control Get Text TabNum(4), 930 To gCfg.LogDir

   If gSrvRunning Then
      Bit Set gCfg.Flag, 3
   Else
      Bit Reset gCfg.Flag, 3
   End If

End Sub

Sub StartWeb()

   Local sWork As String

   If gSrvRunning Then Exit Sub

   'Update all Data!!
   FormSave

   If gCfg.IpAddr = 0 Then
      MsgBox "Invalid TCP/IP Address!",16,"TCP ERROR!"
      gSrvRunning = 0
      Control Send hDlg, 100, %BM_CLICK, 0, 0
      Exit Sub
   End If

   ' Update Controls if anything changed!
   sWork = Format$(gCfg.DefPort)
   Control Set Text TabNum(1), 620, sWork
   sWork = IpToString(gCfg.IpAddr)
   Control Set Text TabNum(1), 630, sWork

   WebDir = gCfg.RootDir
   CGIDir = gCfg.CGIDir

   If DirRecs Then
      Bit Set gCfg.Flag, 2       ' Security Enabled
   Else
      Bit Reset gCfg.Flag, 2     ' Security Disabled
   End If

   If Right$(WebDir,1) <> "\" Then
      WebDir = WebDir & "\"
   End If

   If Right$(CGIDir,1) <> "\" Then
      CGIDir = CGIDir & "\"
   End If

    ' Make room for all of the connections
   ReDim Connections(1:gCfg.MaxConn) As Global ConnectionStruct

   BADCHARS = Chr$(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26)

   ListenSocket = FreeFile

   ' Start TCP/IP listening for connects
   Tcp Open Server Addr gCfg.IpAddr Port gCfg.DefPort As ListenSocket _
   TimeOut 3

   If ErrClear Then
      MsgBox "Error Opening TCP/IP Address!",16,"TCP ERROR!"
      gSrvRunning = 0
      Control Send hDlg, 100, %BM_CLICK, 0, 0
      Exit Sub
   End If

   ' Setup notify for the listening port
   Tcp Notify ListenSocket, Accept To hDlg As %WM_CONNECT

   gSrvRunning = 1  ' Running Flag to ON

   Control Set Image hDlg, 1300, "TLITE_GR"  ' Switch Icon
   Control Set Text hDlg, 1200, "Running"    ' Switch Label

End Sub

Sub StopWeb()

   Local i As Long

   If gSrvRunning = 0 Then Exit Sub

   ' Force all running threads to stop
   For i = 1 To gCfg.MaxConn
       If Connections(i).InUse = 1 Then
          Connections(i).InUse = 2
       End If
   Next i

   Tcp Close ListenSocket  ' Close TCP/IP

   gSrvRunning = 0         ' Server run flag to OFF

   Control Set Image hDlg, 1300, "TLITE_RD"  ' Switch Icon
   Control Set Text hDlg, 1200, "Stopped"    ' Switch Label

End Sub

Sub ControlSetStates(ByVal hInst As Long)

   If gSrvRunning Then
      ti.szTip = "Lil' HTTP Server: Running (" & Format$(gCfg.DefPort) & ")"
      ti.hIcon = LoadIcon(hInst, "TRAY_ICO_GR")
      Shell_NotifyIcon %NIM_MODIFY, ti
      DestroyIcon ti.hIcon
      Menu Delete hMenu, 0
      Menu Add String, hMenu, "Stop Service", 501, %MF_ENABLED, At 1
      Control Disable TabNum(0), 500
      Control Disable TabNum(0), 510
      Control Disable TabNum(0), 520
      Control Disable TabNum(1), 600
      Control Disable TabNum(1), 605
      Control Disable TabNum(1), 610
      Control Disable TabNum(1), 620
      Control Disable TabNum(1), 630
      Control Disable TabNum(1), 640
      Control Disable TabNum(2), 700
      Control Disable TabNum(2), 710
      Control Disable TabNum(2), 720
      Control Disable TabNum(2), 730
      Control Disable TabNum(3), 800
      Control Disable TabNum(3), 810
      Control Disable TabNum(3), 820
      Control Disable TabNum(3), 830
      Control Disable TabNum(4), 900
      Control Disable TabNum(4), 910
      Control Disable TabNum(4), 920
      Control Disable TabNum(4), 930
   Else
      ti.szTip = "Lil' HTTP Server: Stopped"
      ti.hIcon = LoadIcon(hInst, "TRAY_ICO_RD")
      Shell_NotifyIcon %NIM_MODIFY, ti
      DestroyIcon ti.hIcon
      Menu Delete hMenu, 0
      Menu Add String, hMenu, "Start Service", 500, %MF_ENABLED, At 1
      Control Enable TabNum(0), 500
      Control Enable TabNum(0), 510
      Control Enable TabNum(0), 520
      Control Enable TabNum(1), 600
      Control Enable TabNum(1), 605
      Control Enable TabNum(1), 610
      Control Enable TabNum(1), 620
      Control Enable TabNum(1), 630
      Control Enable TabNum(1), 640
      Control Enable TabNum(2), 700
      Control Enable TabNum(2), 710
      Control Enable TabNum(2), 720
      Control Enable TabNum(2), 730
      Control Enable TabNum(3), 800
      Control Enable TabNum(3), 810
      Control Enable TabNum(3), 820
      Control Enable TabNum(3), 830
      Control Enable TabNum(4), 900
      Control Enable TabNum(4), 910
      Control Enable TabNum(4), 920
      Control Enable TabNum(4), 930
   End If

End Sub

Function ActiveConnects() As Dword

   Local i As Dword

   For i = 1 To gCfg.MaxConn
       If Connections(i).InUse Then
          Function = 1
          Exit For
       End If
   Next i

End Function

CallBack Function DirSav
   Local idx As Long

   If CbCtlMsg=%BN_CLICKED Then
      If CbCtl=%IDOK Then
         Control Get Text CbHndl, 100 To SavDirStr
         SavDirStr = Remove$(SavDirStr, Any "/\ ")
         SavDirStr = Trim$(SavDirStr, Any Chr$(32,0))
         If DirRecs Then
            For idx = 1 To DirRecs
                If idx <> DataPos Then
                   If SavDirStr = Dirs(idx).DirName Then
                      MsgBox "Duplicate Name Not Allowed!", _
                         %MB_ICONEXCLAMATION, "Directory Name Error"
                      Exit Function
                   End If
                End If
            Next idx
         End If
         Dialog End CbHndl, 1
      Else
         Dialog End CbHndl, 0
      End If
   End If
End Function

Sub DoDirEdit(ByVal Idx As Long)
   #Register None

   Local i       As Long
   Local dDlg    As Long
   Local Result  As Long
   Local Buffer  As Asciiz * 256

   If Idx = -1 Then Exit Sub  ' Error from LB_GETCURSEL

   DataPos = 0

   If Idx < DirRecs Then  ' Existing Record
      Control Send TabNum(2), 700, %LB_GETTEXT, Idx, VarPtr(Buffer)
      If Len(Buffer) Then
         For i = 1 To DirRecs
             If Buffer = Dirs(i).DirName Then
                Exit For
             End If
         Next i
         If i > DirRecs Then Exit Sub
         DataPos = i
      End If
   End If

   Dialog New hDlg, "Secure Directory Editor",,, 140, 65 To dDlg
   Control Add Frame, dDlg, -1, "Secure Directory Name", 5, 5, 130, 40
   Control Add TextBox, dDlg, 100, Buffer, 10, 20, 120, 14, %WS_TABSTOP Or _
     %ES_UPPERCASE, %WS_EX_CLIENTEDGE
   Control Send dDlg, 100, %WM_SETFONT, hFont1, 1
   Control Add Button, dDlg, %IDOK, "&Save", 80, 50, 40, 12, %BS_DEFAULT Call DirSav
   Control Add Button, dDlg, %IDCANCEL, "&Abort", 20, 50, 40, 12 Call DirSav
   Dialog Show Modal dDlg To Result

   If Result Then
      If Idx = DirRecs Then ' New Record
         Incr DirRecs
         ReDim Preserve Dirs(1:DirRecs) As Global Directs
         Dirs(DirRecs).DirName = SavDirStr
         ListBox Add TabNum(2), 700, SavDirStr
      Else
         Dirs(i).DirName = SavDirStr
         ListBox Delete TabNum(2), 700, Idx+1
         Control Send TabNum(2), 700, %LB_INSERTSTRING, Idx, StrPtr(SavDirStr)
      End If
   End If

End Sub

CallBack Function AddDir
   Local DNum As Long

   If CbCtlMsg=%BN_CLICKED Then
      DNum = DirRecs
      DoDirEdit DNum
   End If

End Function

CallBack Function EditDir
   Local DNum As Long

   If CbCtlMsg=%BN_CLICKED Then
      Control Send TabNum(2), 700, %LB_GETCURSEL, 0,0 To DNum
      DoDirEdit DNum
   End If

End Function

CallBack Function DelDir
   Local DNum As Long
   Local idx  As Long
   Local DStr As Asciiz * 256

   If CbCtlMsg=%BN_CLICKED Then
      Control Send TabNum(2), 700, %LB_GETCURSEL, 0,0 To DNum
      If DNum = -1 Then Exit Function
      Control Send TabNum(2), 700, %LB_GETTEXT, DNum, VarPtr(DStr)
      If Len(DStr) Then
         If MsgBox("Delete Entry : " & DStr & " ?", _
            %MB_ICONEXCLAMATION Or %MB_YESNO Or %MB_DEFBUTTON2, _
            "Delete Directory") = %IDYES Then

            For idx = 1 To DirRecs
                If Dirs(idx).DirName = DStr Then
                   Exit For
                End If
            Next idx
            If idx > DirRecs Then Exit Function
            Array Delete Dirs(idx)
            Decr DirRecs
            If DirRecs Then
               ReDim Preserve Dirs(1:DirRecs) As Global Directs
               ListBox Delete TabNum(2), 700, DNum+1
            Else
               ReDim Dirs(1:1) As Global Directs
               ListBox Reset TabNum(2), 700
            End If
         End If
      End If
   End If

End Function

CallBack Function DirBox
   Local DNum As Long

   If CbCtlMsg=%LBN_DBLCLK Then
      Control Send TabNum(2), 700, %LB_GETCURSEL, 0,0 To DNum
      DoDirEdit DNum
   End If
End Function

' Handle All Buttons and ListBox callbacks for user editor
CallBack Function UsrSav

   Local position As Long
   Local count    As Long
   Local idx      As Long
   Local gd       As Long
   Local buffer   As Asciiz * 256
   Local msg      As Asciiz * 128
   Local cap      As Asciiz * 128
   Local sWork    As String
   Local dt       As SYSTEMTIME

   Select Case CbCtl
      Case 130
        If CbCtlMsg=%BN_CLICKED Then
           Control Send CbHndl, 210, %LB_GETCOUNT, 0,0 To count
           For idx = 0 To count-1
               Control Send CbHndl, 210, %LB_GETTEXT, 0, VarPtr(Buffer)
               ListBox Delete CbHndl, 210, 1
               ListBox Add CbHndl, 200, Buffer
           Next idx
        End If
      Case 140
        If CbCtlMsg=%BN_CLICKED Then
           Control Send CbHndl, 200, %LB_GETCOUNT, 0,0 To count
           For idx = 0 To count-1
               Control Send CbHndl, 200, %LB_GETTEXT, 0, VarPtr(Buffer)
               ListBox Delete CbHndl, 200, 1
               ListBox Add CbHndl, 210, Buffer
           Next idx
        End If
      Case 150
        If CbCtlMsg=%BN_CLICKED Then
           Control Send CbHndl, 210, %LB_GETCURSEL, 0,0 To position
           If position > -1 Then
              Control Send CbHndl, 210, %LB_GETTEXT, position, VarPtr(Buffer)
              ListBox Delete CbHndl, 210, position+1
              ListBox Add CbHndl, 200, Buffer
           End If
        End If
      Case 160
        If CbCtlMsg=%BN_CLICKED Then
           Control Send CbHndl, 200, %LB_GETCURSEL, 0,0 To position
           If position > -1 Then
              Control Send CbHndl, 200, %LB_GETTEXT, position, VarPtr(Buffer)
              ListBox Delete CbHndl, 200, position+1
              ListBox Add CbHndl, 210, Buffer
           End If
        End If
      Case 170
        If CbCtlMsg=%BN_CLICKED Then
           Dialog End CbHndl, 0
        End If
      Case 180
        If CbCtlMsg=%BN_CLICKED Then
           Control Get Text CbHndl, 100 To sWork
           SavUsrRec.UserName = Trim$(sWork, Any Chr$(255,32,0))
           If Len(SavUsrRec.UserName) = 0 Then
              cap = "Form Incomplete!"
              msg = "Login Name cannot be blank!"
              MessageBox CbHndl, msg, cap, %MB_ICONEXCLAMATION
              Exit Function
           End If
           ' Search for Duplicate Login Names
           If UsrRecs Then
              For idx = 1 To UsrRecs
                  If idx <> DataPos Then
                     If SavUsrRec.UserName = User(idx).UserName Then
                        MsgBox "Duplicate Name Not Allowed!", _
                           %MB_ICONEXCLAMATION, "Login Name Error"
                        Exit Function
                     End If
                  End If
              Next idx
           End If
           Control Get Text CbHndl, 110 To sWork
           SavUsrRec.UserPW = Trim$(sWork, Any Chr$(255,32,0))
           If Len(SavUsrRec.UserPW) = 0 Then
              cap = "Form Incomplete!"
              msg = "Password cannot be blank!"
              MessageBox CbHndl, msg, cap, %MB_ICONEXCLAMATION
              Exit Function
           End If
           Control Send CbHndl, 120, %DTM_GETSYSTEMTIME, 0, VarPtr(dt) To gd
           If gd = %GDT_VALID Then
              sWork = Format$(dt.wMonth,"00") & "-" & _
                      Format$(dt.wDay,"00") & "-" & _
                      Format$(dt.wYear, "0000")
              SavUsrRec.UserExp = DateToDays(sWork)
           Else
              SavUsrRec.UserExp = 0   ' No Expiration
           End If
           SavUsrRec.UserDirs = ""    ' Initialize Var
           sWork = ""
           Control Send CbHndl, 200, %LB_GETCOUNT, 0,0 To count
           For idx = 0 To count-1
               Control Send CbHndl, 200, %LB_GETTEXT, idx, VarPtr(Buffer)
               If Len(sWork) Then
                  sWork = sWork & "," & Buffer
               Else
                  sWork = Buffer
               End If
           Next idx
           SavUsrRec.UserDirs = sWork
           Dialog End CbHndl, 1
        End If
      Case 200
        If CbCtlMsg=%LBN_DBLCLK Then
           Control Send CbHndl, 200, %LB_GETCURSEL, 0,0 To position
           If position > -1 Then
              Control Send CbHndl, 200, %LB_GETTEXT, position, VarPtr(Buffer)
              ListBox Delete CbHndl, 200, position+1
              ListBox Add CbHndl, 210, Buffer
           End If
        End If
      Case 210
        If CbCtlMsg=%LBN_DBLCLK Then
           Control Send CbHndl, 210, %LB_GETCURSEL, 0,0 To position
           If position > -1 Then
              Control Send CbHndl, 210, %LB_GETTEXT, position, VarPtr(Buffer)
              ListBox Delete CbHndl, 210, position+1
              ListBox Add CbHndl, 200, Buffer
           End If
        End If
   End Select
End Function

Sub SetButtonImage(ByVal hDlg As Dword, ByVal CtlID As Dword, ImageStr As Asciiz)

   Local hCtl As Dword
   Local hIcc As Dword

   Control Handle hDlg, CtlID To hCtl
   hIcc = LoadIcon(GetWindowLong(hDlg, %GWL_HINSTANCE), ImageStr)

   If hIcc Then
      SendMessage hCtl, %BM_SETIMAGE, %IMAGE_ICON, hIcc
      DeleteObject hIcc
   End If

End Sub

Sub DoUsrEdit(ByVal Idx As Long)
   #Register None

   Local i       As Long
   Local x       As Long
   Local Avails  As Long
   Local Haves   As Long
   Local dDlg    As Long
   Local Result  As Long
   Local Count   As Long
   Local iWork   As Long
   Local sWork   As String
   Local uName   As String
   Local uPass   As String
   Local sz      As Asciiz * 64
   Local Buffer  As Asciiz * 256
   Local dt      As SYSTEMTIME
   Local gd      As Dword

   If Idx = -1 Then Exit Sub  ' Error from LB_GETCURSEL

   sz = "MMM dd, yyyy"    ' Date Formatting String
   DataPos = 0

   If Idx < UsrRecs Then  ' Existing Record
      Control Send TabNum(3), 800, %LB_GETTEXT, Idx, VarPtr(Buffer)
      If Len(Buffer) Then
         For i = 1 To UsrRecs
             If Buffer = User(i).UserName Then
                Exit For
             End If
         Next i
         If i > UsrRecs Then Exit Sub
         DataPos = i
      Else
         Exit Sub
      End If
   End If

   ' We've got our user at this point so figure out what directories
   ' the user has access to and which ones are available and build
   ' the 2 list box arrays.

   If DirRecs Then
      Haves = DirRecs
      Dim AvailDirs(1:DirRecs) As String
      For iWork = 1 To DirRecs
          AvailDirs(iWork) = Dirs(iWork).DirName
      Next iWork
      If Idx < UsrRecs Then ' Existing User: Check Allowed Dirs
         If Len(User(i).UserDirs) Then
            Count = ParseCount(User(i).UserDirs,",")
            Dim HaveDirs(1:Count) As String
            For iWork = 1 To Count
                HaveDirs(iWork) = Parse$(User(i).UserDirs,",",iWork)
            Next iWork

            ' Next Compare the 2 arrays and make sure that
            '   A. All names in "Have" are removed from "Avail"
            '   B. If name is NOT in "Avail" that it is removed
            '      from "Have"

            Haves = Count
            Avails = DirRecs
            iWork = 1

            Do
               Array Scan AvailDirs(), = HaveDirs(iWork), To x
               If x Then
                  Array Delete AvailDirs(x)
                  Decr Avails
                  If Avails Then
                     ReDim Preserve AvailDirs(1:Avails) As String
                  Else
                     ReDim AvailDirs(1:1) As String
                  End If
               Else
                  Array Delete HaveDirs(iWork)
                  Decr Haves
                  If Haves Then
                     ReDim Preserve HaveDirs(1:Haves) As String
                  Else
                     ReDim HaveDirs(1:1) As String
                  End If
                  If Haves < iWork Then Exit Loop
                  Iterate  ' Do Not Incr iWork since we deleted one!
               End If
               Incr iWork
               If iWork > Haves Then Exit Loop
            Loop
         Else
            Dim HaveDirs(1:1) As String
            Haves = 0
         End If
      Else
         Dim HaveDirs(1:1) As String
         Haves = 0
      End If
   Else
      Dim AvailDirs(1:1) As String
      Dim HaveDirs(1:1) As String
      Haves = 0
      Avails = 0
   End If

   If Idx < UsrRecs Then
      uName = User(i).UserName
      uPass = User(i).UserPW
      If User(i).UserExp = 0 Then
         gd = %GDT_NONE
      Else
         gd = %GDT_VALID
         sWork = DaysToDate(User(i).UserExp)
         dt.wMonth = Val(Mid$(sWork,1,2))
         dt.wDay   = Val(Mid$(sWork,4,2))
         dt.wYear  = Val(Mid$(sWork,7,4))
      End If
   Else
      gd = %GDT_NONE
   End If

   Dialog New hDlg, "User Account Editor",,, 270, 165 To dDlg
   Control Add Frame, dDlg, -1, "", 5, 5, 260, 60
   Control Add Label, dDlg, -1, "&Login Name", 10, 10, 120, 8
   Control Add TextBox, dDlg, 100, uName, 10, 20, 120, 14

   Control Add Label, dDlg, -1, "&Password", 10, 35, 120, 8
   Control Add TextBox, dDlg, 110, uPass, 10, 45, 120, 14

   Control Add Label, dDlg, -1, "&Account Expiration", 140, 10, 100, 8
   Control Add "SysDateTimePick32", dDlg, 120, "", 140, 20, 120, 14, %WS_CHILD Or _
        %WS_TABSTOP Or %WS_VISIBLE Or %DTS_SHORTDATEFORMAT Or %DTS_SHOWNONE,,
   Control Send dDlg, 120, %DTM_SETFORMAT, 0, VarPtr(sz)
   Control Send dDlg, 120, %DTM_SETSYSTEMTIME, gd, VarPtr(dt)

   Control Add Label, dDlg, -1, "Directories Allowed for User", 10, 75, 120, 8
   Control Add ListBox, dDlg, 200, HaveDirs(), 10, 85, 120, 56, _
      %LBS_DISABLENOSCROLL Or %LBS_SORT Or %WS_TABSTOP Or %WS_VSCROLL, _
      %WS_EX_CLIENTEDGE Call UsrSav

   Control Add Label, dDlg, -1, "Available Secured Directories", 140, 75, 120, 8
   Control Add ListBox, dDlg, 210, AvailDirs(), 140, 85, 120, 56, _
      %LBS_DISABLENOSCROLL Or %LBS_SORT Or %WS_TABSTOP Or %WS_VSCROLL, _
      %WS_EX_CLIENTEDGE Call UsrSav

   Control Add Button, dDlg, 130, "A&ll", 10, 145, 30, 14   Call UsrSav
   Control Add Button, dDlg, 140, "&Clear", 54, 145, 30, 14 Call UsrSav
   Control Add Button, dDlg, 150, "&Add", 98, 145, 30, 14   Call UsrSav
   Control Add Button, dDlg, 160, "&Del", 142, 145, 30, 14  Call UsrSav
   Control Add Button, dDlg, 170, "&Quit", 186, 145, 30, 14 Call UsrSav
   Control Add Button, dDlg, 180, "&Save", 230, 145, 30, 14 Call UsrSav

   Dialog Show Modal dDlg To Result

   If Result Then
      If Idx = UsrRecs Then ' New Record
         Incr UsrRecs
         ReDim Preserve User(1:UsrRecs) As Global UserAcct
         User(UsrRecs) = SavUsrRec
         ListBox Add TabNum(3), 800, SavUsrRec.UserName
      Else
         User(i) = SavUsrRec
         SavDirStr = SavUsrRec.UserName
         ListBox Delete TabNum(3), 800, Idx+1
         Control Send TabNum(3), 800, %LB_INSERTSTRING, Idx, StrPtr(SavDirStr)
      End If
   End If

End Sub

CallBack Function AddUsr

   Local UNum As Long

   If CbCtlMsg=%BN_CLICKED Then
      UNum = UsrRecs
      DoUsrEdit UNum
   End If

End Function

CallBack Function EditUsr
   Local UNum As Long

   If CbCtlMsg=%BN_CLICKED Then
      Control Send TabNum(3), 800, %LB_GETCURSEL, 0,0 To UNum
      DoUsrEdit UNum
   End If

End Function

CallBack Function DelUsr

   Local UNum As Long
   Local idx  As Long
   Local DStr As Asciiz * 256

   If CbCtlMsg=%BN_CLICKED Then
      Control Send TabNum(3), 800, %LB_GETCURSEL, 0,0 To UNum
      If UNum = -1 Then Exit Function
      Control Send TabNum(3), 800, %LB_GETTEXT, UNum, VarPtr(DStr)
      If Len(DStr) Then
         If MsgBox("Delete User : " & DStr & " ?", _
            %MB_ICONEXCLAMATION Or %MB_YESNO Or %MB_DEFBUTTON2, _
            "Delete Directory") = %IDYES Then

            For idx = 1 To UsrRecs
                If User(idx).UserName = DStr Then
                   Exit For
                End If
            Next idx

            If idx > UsrRecs Then Exit Function

            Array Delete User(idx)
            Decr UsrRecs
            If UsrRecs Then
               ReDim Preserve User(1:UsrRecs) As Global UserAcct
               ListBox Delete TabNum(3), 800, UNum+1
            Else
               ReDim User(1:1) As Global UserAcct
               ListBox Reset TabNum(3), 800
            End If
         End If
      End If
   End If

End Function

CallBack Function UsrBox
   Local UNum As Long

   If CbCtlMsg=%LBN_DBLCLK Then
      Control Send TabNum(3), 800, %LB_GETCURSEL, 0,0 To UNum
      DoUsrEdit UNum
   End If

End Function

CallBack Function MainWndProc As Long

   Local hInst      As Long
   Local i          As Long
   Static RunBefSus As Long

   hInst   = GetWindowLong(hDlg, %GWL_HINSTANCE)

   Select Case CbMsg
       Case %WM_CONNECT
           Select Case LoWrd(CbLParam)

               Case %FD_ACCEPT
                   For i = 1 To gCfg.MaxConn
                       If Connections(i).InUse = 0 Then
                          ' Get a new handle
                          Connections(i).hSocket = FreeFile
                          ' Accept the connection and create a new socket
                          Tcp Accept ListenSocket As Connections(i).hSocket
                          ' Capture Close Notifications
                          Tcp Notify Connections(i).hSocket, Close To hDlg As %WM_CONNECT
                          ' Flag the Thread as "INUSE"
                          Connections(i).InUse = 1
                          ' Start the thread to handle the socket
                          Thread Create SocketThread(i) To Connections(i).hThread
                          Exit For
                       End If
                   Next i
               Case %FD_CLOSE
                   For i = 1 To gCfg.MaxConn
                       If FileAttr(Connections(i).hSocket, 2) = CbWParam Then
                          ' Flag it for a Kill, Timer will clean it up.
                          ' 3 = Request Close
                          Connections(i).InUse = 3
                          Exit For
                       End If
                   Next i
           End Select
           Function = 0
           Exit Function

       Case %WM_QUERYENDSESSION
         ' ** Windows is trying to Shutdown and we're still running
         ' ** Stop the service and return 0
         FormSave
         i = WriteSettings
         If gSrvRunning Then
            StopWeb
         End If

         Function = 0   ' Ok to shutdown!  1 Means NOT OK!

       Case %WM_CTLCOLORMSGBOX , %WM_CTLCOLORBTN, %WM_CTLCOLOREDIT,_
            %WM_CTLCOLORSTATIC, %WM_CTLCOLORSCROLLBAR, %WM_CTLCOLORLISTBOX
           ' Control colors
           Select Case GetDlgCtrlID(CbLParam)
               Case 1000
                   SetTextColor CbWParam, RGB(0,0, 255)
                   SetBkMode   CbWParam, %TRANSPARENT
                   Function=GetSysColorBrush(4)
               Case  1100 ' FRAME
                   SetTextColor CbWParam, RGB(0,0,128)
                   SetBkMode   CbWParam, %TRANSPARENT
                   Function=GetSysColorBrush(4)
               Case Else
                   Function=0
           End Select

       Case %WM_NOTIFY  ' Tab control notifications

           Local lpNmh As NMHDR Ptr
           lpNmh =  CbLParam

           Select Case CbWParam
              Case 2000       'A tab was clicked
                 Local lPage As Long
                 lPage = TabCtrl_GetCurSel(GetDlgItem(CbHndl, 2000))

                 Select Case @lpNmh.Code  'All Tab control Notification Messages
                    Case %TCN_SELCHANGING 'A tab-page is about to change, hide it
                       Dialog Show State TabNum(lPage), %SW_HIDE
                       Function = 0

                    Case %TCN_SELCHANGE   'Show selected tab page
                       Dialog Show State TabNum(lPage), %SW_SHOW
                       Function = 0

                 End Select
           End Select

       Case %WM_DESTROY
         ' ** Remove the tray icon if the application is closed
         Shell_NotifyIcon %NIM_DELETE, ti

       Case %WM_INITDIALOG

         If CbWParam <> hDlg Then Exit Function

         Menu New PopUp To hMenu
         Menu Add String, hMenu, "Start Service", 500, %MF_ENABLED
         Menu Add String, hMenu, "About Program", 502, %MF_ENABLED
         Menu Add String, hMenu, "-", -1, %MF_ENABLED
         Menu Add String, hMenu, "&Unload HTTP Server", %IDCANCEL, %MF_ENABLED

         ' ** Add tray icon
         ti.cbSize           = SizeOf(ti)
         ti.hWnd             = hDlg
         ti.uID              = hInst
         ti.uFlags           = %NIF_ICON Or %NIF_MESSAGE Or %NIF_TIP
         ti.uCallbackMessage = %WM_TRAYICON
         ti.hIcon            = LoadIcon(hInst, "TRAY_ICO_RD")
         ti.szTip            = "Lil' HTTP Server: Stopped"
         Shell_NotifyIcon %NIM_ADD, ti
         DestroyIcon ti.hIcon

         Function = 1

       Case %WM_TRAYICON

         Select Case LoWrd(CbLParam)

           ' ** Left button press
           Case %WM_LBUTTONDBLCLK
           'Case %WM_LBUTTONDOWN
             If IsWindowVisible(hDlg) = %FALSE Then
               ShowWindow hDlg, %SW_SHOW
             End If

           ' ** Right button press
           Case %WM_RBUTTONDOWN
             If IsWindowVisible(hDlg) = %FALSE Then
               SetForegroundWindow hDlg
               GetCursorPos p
               TrackPopupMenu hMenu, %TPM_LEFTALIGN Or %TPM_RIGHTBUTTON, p.x, p.y, 0, hDlg, ByVal 0
               Postmessage hDlg, %WM_NULL, 0, 0
             End If

         End Select

       Case %WM_COMMAND
         Select Case LoWrd(CbWParam)

                Case 500
                     If CbCtlMsg=%BN_CLICKED Then
                        Control Send hDlg, 110, %BM_CLICK, 0, 0
                     End If

                Case 501
                     If CbCtlMsg=%BN_CLICKED Then
                        Control Send hDlg, 100, %BM_CLICK, 0, 0
                     End If

                Case 502
                     If CbCtlMsg=%BN_CLICKED Then
                        AboutProgram
                     End If

                Case 130
                     If CbCtlMsg=%BN_CLICKED Then
                        ShowWindow hDlg, %SW_HIDE
                        Function = 1
                        Exit Function
                     End If

                Case 120
                     If CbCtlMsg=%BN_CLICKED Then
                        AboutProgram
                     End If

                Case 110
                     If CbCtlMsg=%BN_CLICKED Then
                        StartWeb
                        ControlSetStates hInst
                     End If

                Case 100
                     If CbCtlMsg=%BN_CLICKED Then
                        If ActiveConnects Then
                           If MsgBox("Warning Server has ACTIVE Connections, Stop it Anyway?", _
                              %MB_ICONEXCLAMATION Or %MB_YESNO Or %MB_DEFBUTTON2, _
                              "Stop Service?") = 6 Then
                              StopWeb
                              ControlSetStates hInst
                           Else
                              ' Push Start Button Again Since abort
                              Control Send hDlg, 110, %BM_CLICK, 0, 0
                           End If
                        Else
                           StopWeb
                           ControlSetStates hInst
                        End If
                     End If

                Case %IDCANCEL
                     If CbCtlMsg=%BN_CLICKED Then
                        If ActiveConnects Then
                           If MsgBox("Warning Server has ACTIVE Connections, Shutdown Anyway?", _
                              %MB_ICONEXCLAMATION Or %MB_YESNO Or %MB_DEFBUTTON2, _
                              "Stop Server and Unload?") = 6 Then
                              FormSave
                              Dialog End hDlg, 1
                           End If
                        Else
                           If MsgBox("Completely Shutdown HTTP Server and remove icon from the tray?", _
                              %MB_ICONEXCLAMATION Or %MB_YESNO Or %MB_DEFBUTTON2, _
                              "Unload Server?") = 6 Then
                              FormSave
                              Dialog End hDlg, 1
                           End If
                        End If
                        Function = 1
                     End If
         End Select

       Case %WM_SYSCOMMAND

         ' ** If either the minimize or close buttons are pressed, hide the
         '    window so it doesn't appear in the task bar.

         Select Case LoWrd(CbWParam)

           Case %SC_MINIMIZE
             ShowWindow hDlg, %SW_HIDE
             Function = 1
             Exit Function

           Case %SC_CLOSE
             ShowWindow hDlg, %SW_HIDE
             Function = 1
             Exit Function

         End Select

       Case %WM_POWERBROADCAST   ' Power Management Messages
         Select Case CbWParam
           Case %PBT_APMSUSPEND  ' System About to Suspend
             If gSrvRunning Then
                RunBefSus = -1   ' Save Run Status
                StopWeb          ' Stop The Server
             Else
                RunBefSus = 0
             End If
             Function = 1
           Case %PBT_APMRESUMESUSPEND  ' System just resumed
             If RunBefSus Then
                StartWeb
             End If
         End Select

       Case Else

   End Select

End Function

Sub MainWnd
   #Register None

   Local hTabMain  As Long
   Local tie       As TC_ITEM
   Local sTmp      As String
   Local idx       As Dword
   Local hIco      As Long
   Local Rslt      As Long
   Local Result    As Long
   Local IpAddr    As Long

   Dim LBList(0)   As String ' Default for ListBoxes

   ReDim TabNum(4) As Global Long

   tie.mask = %TCIF_TEXT

   ' Create Dialog

   Dialog New 0, $ApTitle,,, 270, 170, %WS_MINIMIZEBOX Or %WS_SYSMENU, _
            %WS_EX_CONTROLPARENT To hDlg

   ' Add a Timer Event

   Rslt = SetTimer(hDlg, 400, 5000, CodePtr(CleanUpThreads))
   If Rslt <> 400 Then
      MsgBox "Error Establishing Timer Event!",16,"ERROR!"
      Exit Sub
   End If

   ' Add Dialog Icon to System Menu
   hIco = LoadIcon(GetWindowLong(hDlg, %GWL_HINSTANCE), "APP_ICON")
   If hIco Then Dialog Send hDlg, %WM_SETICON, %ICON_BIG, hIco

   Control Add Label, hDlg,  1000,  "Lil' HTTP Server Configuration", 27, 5, 232, 12
   Control Send hDlg,  1000, %WM_SETFONT, hFont2, 1

   Control Add Frame, hDlg,  1100,  "Controls", 154, 37, 109, 108, _
       %WS_CHILD Or %WS_VISIBLE Or %BS_GROUPBOX, _
       %WS_EX_TRANSPARENT
   Control Send hDlg,  1100, %WM_SETFONT, hFont1, 1

   Control Add Label, hDlg,  1200,  "Stopped", 228, 62, 29, 12, _
       %WS_CHILD Or %WS_VISIBLE Or %SS_CENTER

   Control Add Image, hDlg,  1300, "TLITE_RD", 233, 74, 21, 20, _
       %WS_CHILD Or %WS_VISIBLE Or %SS_ICON Or %SS_NOTIFY Call ThreadStatus

   Control Add Image, hDlg,  1400, "FORM_ICO", 3, 2, 21, 20, _
       %WS_CHILD Or %WS_VISIBLE Or %SS_ICON

   Control Add Label, hDlg, -1, "Current Connects", 160, 25, 60, 10
   Control Add Label, hDlg, 1500, "0", 220, 25, 40, 10, %SS_SUNKEN

   Control Add Label, hDlg,  -1,  "Stop", 229, 101, 29, 10, _
       %WS_CHILD Or %WS_VISIBLE Or %SS_CENTER
   Control Add Label, hDlg,  -1,  "Start", 197, 101, 27, 10, _
       %WS_CHILD Or %WS_VISIBLE Or %SS_CENTER
   Control Add Label, hDlg,  -1,  "Info", 159, 101, 27, 10, _
       %WS_CHILD Or %WS_VISIBLE Or %SS_CENTER
   Control Add Label, hDlg,  -1,  "Exit", 196, 62, 27, 10, _
       %WS_CHILD Or %WS_VISIBLE Or %SS_CENTER
   Control Add Label, hDlg,  -1,  "Minimize", 159, 62, 27, 12, _
       %WS_CHILD Or %WS_GROUP Or %WS_VISIBLE Or %SS_CENTER

   ' Stop Button (100)
   Control Add "Button", hDlg,  100, "", 231, 111, 27, 25, _
       %WS_CHILD Or %WS_VISIBLE Or %BS_AUTORADIOBUTTON Or %BS_PUSHLIKE Or _
       %BS_ICON Or %WS_GROUP Or %WS_TABSTOP
   SetButtonImage hDlg, 100, "STOPBTN"

   ' Start Button (110)
   Control Add "Button", hDlg,  110, "", 197, 111, 27, 25, _
       %WS_CHILD Or %WS_VISIBLE Or %BS_AUTORADIOBUTTON Or %BS_PUSHLIKE Or _
       %BS_ICON Or %WS_TABSTOP
   SetButtonImage hDlg,  110, "STARTBTN"

   ' Info Button (120)
   Control Add "Button", hDlg,  120, "", 159, 111, 27, 25, _
       %WS_CHILD Or %WS_GROUP Or %WS_VISIBLE Or %BS_PUSHBUTTON Or %BS_ICON Or %WS_TABSTOP
   SetButtonImage hDlg,  120, "INFOBTN"

   ' Minimize Button (130)
   Control Add "Button", hDlg,  130, "", 159, 74, 27, 25, _
       %WS_CHILD Or %WS_VISIBLE Or %BS_PUSHBUTTON Or %BS_ICON Or %WS_TABSTOP
   SetButtonImage hDlg,  130, "MINIBTN"

   ' Exit Button (%IDCANCEL)
   Control Add "Button", hDlg,  %IDCANCEL, "", 197, 74, 27, 25, _
       %WS_CHILD Or %WS_VISIBLE Or %BS_PUSHBUTTON Or %BS_ICON Or %WS_TABSTOP
   SetButtonImage hDlg,  %IDCANCEL, "EXITBTN"

   ' Add Tab Control(2000)

   Control Add "SysTabControl32", hDlg, 2000, "", 3, 28, 145, 117, _
               %WS_CHILD Or %WS_VISIBLE Or %WS_TABSTOP Or %TCS_TOOLTIPS Or _
               %TCS_TABS Or %TCS_FOCUSONBUTTONDOWN Or %WS_CLIPSIBLINGS Or _
               %TCS_MULTILINE

   Control Handle hDlg, 2000 To hTabMain

   '-----------------------------------------------------------
   ' Place Tabs and supporting Dialogs in Tab Control
   '-----------------------------------------------------------
   sTmp = " Directories "
   tie.pszText = StrPtr(sTmp)
   Call TabCtrl_InsertItem(hTabMain, 0, tie)
   Dialog New hDlg,"" , 5, 55, 141, 88, %WS_CHILD Or %DS_CONTROL, 0 To TabNum(0)

   sTmp = " Settings "
   tie.pszText = StrPtr(sTmp)
   Call TabCtrl_InsertItem(hTabMain, 1, tie)
   Dialog New hDlg,"" , 5, 55, 141, 88, %WS_CHILD Or %DS_CONTROL, 0 To TabNum(1)

   sTmp = " Security "
   tie.pszText = StrPtr(sTmp)
   Call TabCtrl_InsertItem(hTabMain, 2, tie)
   Dialog New hDlg,"" , 5, 55, 141, 88, %WS_CHILD Or %DS_CONTROL, 0 To TabNum(2)

   sTmp = " Users "
   tie.pszText = StrPtr(sTmp)
   Call TabCtrl_InsertItem(hTabMain, 3, tie)
   Dialog New hDlg,"" , 5, 55, 141, 88, %WS_CHILD Or %DS_CONTROL, 0 To TabNum(3)

   sTmp = "  Logging "
   tie.pszText = StrPtr(sTmp)
   Call TabCtrl_InsertItem(hTabMain, 4, tie)
   Dialog New hDlg,"" , 5, 55, 141, 88, %WS_CHILD Or %DS_CONTROL, 0 To TabNum(4)

   Dialog Show Modeless TabNum(4) Call MainWndProc
   Dialog Show State TabNum(4), %SW_HIDE
   Dialog Show Modeless TabNum(3) Call MainWndProc
   Dialog Show State TabNum(3), %SW_HIDE
   Dialog Show Modeless TabNum(2) Call MainWndProc
   Dialog Show State TabNum(2), %SW_HIDE
   Dialog Show Modeless TabNum(1) Call MainWndProc
   Dialog Show State TabNum(1), %SW_HIDE
   Dialog Show Modeless TabNum(0) Call MainWndProc
   Dialog Show State TabNum(0), %SW_SHOW

   '-----------------------------------------------------------
   ' Add Controls To Tab 1  (Directories)
   '-----------------------------------------------------------

   Control Add Label, TabNum(0), -1, "Web Server &Root", 10, 5, 110, 8
   Control Add TextBox, TabNum(0), 500,  "", 10, 15, 120, 12, _
       %ES_AUTOHSCROLL Or %WS_TABSTOP, %WS_EX_CLIENTEDGE
   Control Send TabNum(0), 500, %WM_SETFONT, hFont1, 1

   Control Add Label, TabNum(0),  -1,  "&CGI Directory", 10, 30, 110, 8
   Control Add TextBox, TabNum(0), 510,  "", 10, 40, 120, 12, _
       %ES_AUTOHSCROLL Or %WS_TABSTOP, %WS_EX_CLIENTEDGE
   Control Send TabNum(0), 510, %WM_SETFONT, hFont1, 1

   Control Add Label, TabNum(0),  -1,  "&Startup File Name", 10, 55, 110, 8
   Control Add TextBox, TabNum(0), 520,  "", 10, 65, 120, 12, _
       %ES_AUTOHSCROLL Or %WS_TABSTOP, %WS_EX_CLIENTEDGE
   Control Send TabNum(0), 520, %WM_SETFONT, hFont1, 1

   '-----------------------------------------------------------
   ' Add Controls To Tab 2  (Settings)
   '-----------------------------------------------------------

   Control Add Label, TabNum(1), -1, "&Max Connects", 10, 5, 55, 8
   Control Add TextBox, TabNum(1), 600,  "", 10, 15, 50, 12, _
       %ES_AUTOHSCROLL Or %ES_NUMBER Or %WS_TABSTOP, %WS_EX_CLIENTEDGE

   Control Add CheckBox, TabNum(1), 605, "Reg content-type", 70, 7, 70, 8
   Control Add CheckBox, TabNum(1), 610, "Enable SSI", 70, 19, 55, 8

   Control Add Label, TabNum(1), -1, "Default &Port", 10, 30, 55, 8
   Control Add TextBox, TabNum(1), 620,  "", 10, 40, 50, 12, _
       %ES_AUTOHSCROLL Or %ES_NUMBER Or %WS_TABSTOP, %WS_EX_CLIENTEDGE

   Control Add Label, TabNum(1), -1, "Server &IP Addr", 70, 30, 55, 8
   Control Add TextBox, TabNum(1), 630,  "", 70, 40, 60, 12, _
       %ES_AUTOHSCROLL Or %WS_TABSTOP, %WS_EX_CLIENTEDGE

   Control Add Label, TabNum(1),  -1,  "Server &Name", 10, 55, 110, 8
   Control Add TextBox, TabNum(1), 640,  "", 10, 65, 120, 12, _
       %ES_AUTOHSCROLL Or %WS_TABSTOP, %WS_EX_CLIENTEDGE

   '-----------------------------------------------------------
   ' Add Controls To Tab 3  (Security)
   '-----------------------------------------------------------

   Control Add Label, TabNum(2), -1, "Secured Directories", 10, 5, 110, 8
   Control Add ListBox, TabNum(2), 700, LBList(), 10, 15, 120, 56, _
      %LBS_DISABLENOSCROLL Or %LBS_SORT Or %WS_TABSTOP Or %WS_VSCROLL, _
      %WS_EX_CLIENTEDGE Call DirBox
   Control Add Button, TabNum(2), 710, "&Add", 10, 70, 30, 14 Call AddDir
   Control Add Button, TabNum(2), 720, "&Edit", 55, 70, 30, 14 Call EditDir
   Control Add Button, TabNum(2), 730, "&Del", 100, 70, 30, 14 Call DelDir


   '-----------------------------------------------------------
   ' Add Controls To Tab 4  (Users)
   '-----------------------------------------------------------

   Control Add Label, TabNum(3), -1, "System Users", 10, 5, 110, 8
   Control Add ListBox, TabNum(3), 800, LBList(), 10, 15, 120, 56, _
      %LBS_DISABLENOSCROLL Or %LBS_SORT Or %WS_TABSTOP Or %WS_VSCROLL, _
      %WS_EX_CLIENTEDGE Call UsrBox
   Control Add Button, TabNum(3), 810, "&Add", 10, 70, 30, 14 Call AddUsr
   Control Add Button, TabNum(3), 820, "&Edit", 55, 70, 30, 14 Call EditUsr
   Control Add Button, TabNum(3), 830, "&Del", 100, 70, 30, 14 Call DelUsr


   '-----------------------------------------------------------
   ' Add Controls To Tab 5  (Logging)
   '-----------------------------------------------------------

   Control Add Option, TabNum(4), 900, "&Disable Logging", 10, 15, 95, 8, _
      %WS_GROUP Or %WS_TABSTOP
   Control Add Option, TabNum(4), 910, "Log All Hits (Incl. Grphcs)", 10, 25, 95, 8
   Control Add Option, TabNum(4), 920, "Log Only Text/Html Hits", 10, 35, 95, 8

   Control Add Label, TabNum(4), -1, "Log Files Directory", 10, 50, 110, 8
   Control Add TextBox, TabNum(4), 930, "", 10, 60, 120, 12, %WS_GROUP Or _
      %WS_TABSTOP, %WS_EX_CLIENTEDGE

   FormLoad

   Dialog Show Modeless hDlg Call MainWndProc To Result

   ' Tool Tips for Buttons
   SetToolTip GetDlgItem(hDlg, 100),  "Stop the Server"
   SetToolTip GetDlgItem(hDlg, 110),  "Start the Server"
   SetToolTip GetDlgItem(hDlg, 120),  "About Lil' HTTP Server"
   SetToolTip GetDlgItem(hDlg, 130),  "Minimize To Tray"
   SetToolTip GetDlgItem(hDlg, 140),  "Close And Unload Server"

   ' Tab 1 Tool Tips
   SetToolTip GetDlgItem(TabNum(0), 500), "Enter the Servers Root Directory Name"
   SetToolTip GetDlgItem(TabNum(0), 510), "Enter the Directory for CGI Scripts"
   SetToolTip GetDlgItem(TabNum(0), 520), "Default Startup File eg. (index.html)"

   ' Tab 2 Tool Tips
   SetToolTip GetDlgItem(TabNum(1), 600), "Maximum Allowable Connections"
   SetToolTip GetDlgItem(TabNum(1), 605), "Use Registry Settings for content-types"
   SetToolTip GetDlgItem(TabNum(1), 610), "Server Side Includes On/Off"
   SetToolTip GetDlgItem(TabNum(1), 620), "Default Port Setting (Standard is 80)"
   SetToolTip GetDlgItem(TabNum(1), 630), "TCP/IP Address for your Server to use"
   SetToolTip GetDlgItem(TabNum(1), 640), "Your HTTP Server Name"

   ' Tab 3 Tool Tips
   SetToolTip GetDlgItem(TabNum(2), 700), "List Of Directories that require a password"
   SetToolTip GetDlgItem(TabNum(2), 710), "Add a directory to the list"
   SetToolTip GetDlgItem(TabNum(2), 720), "Edit the currently selected directory"
   SetToolTip GetDlgItem(TabNum(2), 730), "Delete the currently selected directory"

   ' Tab 4 Tool Tips
   SetToolTip GetDlgItem(TabNum(3), 800), "List Of UserNames for this server"
   SetToolTip GetDlgItem(TabNum(3), 810), "Add a user to the list"
   SetToolTip GetDlgItem(TabNum(3), 820), "Edit the currently selected user"
   SetToolTip GetDlgItem(TabNum(3), 830), "Delete the currently selected user"

   ' Tab 5 Tool Tips
   SetToolTip GetDlgItem(TabNum(4), 900), "All Logging Disabled"
   SetToolTip GetDlgItem(TabNum(4), 910), "Log All Hits for all file types"
   SetToolTip GetDlgItem(TabNum(4), 920), "Log only hits on HTML or TXT files"
   SetToolTip GetDlgItem(TabNum(4), 930), "Directory in which to store log files"

   For idx = 1 To 50
       Dialog DoEvents
   Next idx

   ' See if TCP/IP is installed

   Host Addr To IpAddr

   If IpAddr <> 0 Then  ' OK Set Last Status of Server

      If InStr(UCase$(Command$),"/R") Then  ' Command Line invoked
         Control Send hDlg, 110, %BM_CLICK, 0, 0 ' Start Service
      Else
         If Bit(gCfg.Flag,3) Then  ' Server ON
            Control Send hDlg, 110, %BM_CLICK, 0, 0
         Else                      ' Server OFF
            Control Send hDlg, 100, %BM_CLICK, 0, 0
         End If
      End If

      If InStr(UCase$(Command$), "/M") Then ' Command Line invoked
         Postmessage hDlg, %WM_SYSCOMMAND, %SC_MINIMIZE, 0
      End If

      ControlSetStates GetWindowLong(hDlg, %GWL_HINSTANCE)

   Else  ' NO TCP/IP Installed!

      Control Send hDlg, 100, %BM_CLICK, 0, 0
      ControlSetStates GetWindowLong(hDlg, %GWL_HINSTANCE)
      MsgBox "Lil' HTTP Server Requires TCP/IP to be installed!",16,"NO TCP/IP ERROR!"
      Control Disable hDlg, 110
      EnableMenuItem hMenu, 500, %MF_GRAYED

   End If

   ' Main Message Pump for TCP/IP and Main Form
   While Result = 0
         Dialog DoEvents
   Wend

   If hIco Then DeleteObject hIco  ' Clean Up Icon Handle

End Sub


Function PBMain As Long

   Local icc       As INIT_COMMON_CONTROLSEX
   Local TempDir As String

   ' Create a LOCK File so that only 1 copy per directory can run at a time

   TempDir = GetDataPath

   If Right$(TempDir,1) <> "\" Then TempDir = TempDir & "\"

   Open TempDir & "LILHTTP.LCK" For Binary Lock Read Write As 1
   If ErrClear Then
      MsgBox "Only 1 copy of Lil HTTP Server (per directory) may be run at a time", _
         64, "Notice!"
      Exit Function
   End If

   ' Initialize Tab Control & Calendar Control

   icc.dwICC = %ICC_TAB_CLASSES Or %ICC_DATE_CLASSES
   icc.dwSize = SizeOf(icc)
   InitCommonControls
   InitCommonControlsEx icc

   If ReadSettings = 0 Then
      MsgBox "Failure to read settings, cannot start!",16,"ERROR!"
      Exit Function
   End If

   ' Setup Array to hold connection info.
   ReDim Connections(1:gCfg.MaxConn) As Global ConnectionStruct

   ' These are System Fonts DO NOT DELETE Handle or Windows
   ' Will lose the use of them also!!
   hFont1 = GetStockObject(%SYSTEM_FIXED_FONT)
   hFont2 = GetStockObject(%SYSTEM_FONT)

   MainWnd  ' Show the main Window

   If WriteSettings = 0 Then
      MsgBox "Could Not Save Settings!",16,"ERROR!"
   End If

   Close 1

   Kill TempDir & "LILHTTP.LCK"

End Function
